/* Generated by re2c 1.0.3 */
// University of Illinois/NCSA
// Open Source License
//
// Copyright (c) 2013-2015, Advanced Micro Devices, Inc.
// All rights reserved.
//
// Developed by:
//
//     HSA Team
//
//     Advanced Micro Devices, Inc
//
//     www.amd.com
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal with
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
//     * Redistributions of source code must retain the above copyright notice,
//       this list of conditions and the following disclaimers.
//
//     * Redistributions in binary form must reproduce the above copyright notice,
//       this list of conditions and the following disclaimers in the
//       documentation and/or other materials provided with the distribution.
//
//     * Neither the names of the LLVM Team, University of Illinois at
//       Urbana-Champaign, nor the names of its contributors may be used to
//       endorse or promote products derived from this Software without specific
//       prior written permission.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
// FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE
// SOFTWARE.


#define YYFILL(n) { readChars(n); }

#include <sstream>

namespace HSAIL_ASM
{

void Scanner::readSingleStringLiteral(Token &t, std::string& outString)
{
    using namespace std;
    const char * &curPos = t.m_text.end;
    while(true) {
        const char *const prevPos = curPos;
        const char *marker;


{
        char yych;
        yych = *curPos;
        switch (yych) {
        case '\n':
        case '\r':        goto yy5;
        case '"':        goto yy7;
        case '\\':        goto yy9;
        default:        goto yy2;
        }
yy2:
        yych = *++curPos;
        switch (yych) {
        case '\n':
        case '\r':
        case '"':
        case '\\':        goto yy4;
        default:        goto yy2;
        }
yy4:
        { outString.insert(outString.end(), prevPos, curPos); continue; }
yy5:
        ++curPos;
        { syntaxError(prevPos, "Runaway string literal"); }
yy7:
        ++curPos;
        { curPos = prevPos; break; }
yy9:
        yych = *(marker = ++curPos);
        switch (yych) {
        case '"':        goto yy11;
        case '\'':        goto yy13;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':        goto yy15;
        case '?':        goto yy17;
        case 'X':
        case 'x':        goto yy19;
        case '\\':        goto yy21;
        case 'a':        goto yy23;
        case 'b':        goto yy25;
        case 'f':        goto yy27;
        case 'n':        goto yy29;
        case 'r':        goto yy31;
        case 't':        goto yy33;
        case 'v':        goto yy35;
        default:        goto yy10;
        }
yy10:
        { syntaxError(curPos, "Invalid escape sequence"); }
yy11:
        ++curPos;
        { outString.push_back('\042'); continue; }
yy13:
        ++curPos;
        { outString.push_back('\047'); continue; }
yy15:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':        goto yy37;
        default:        goto yy16;
        }
yy16:
        {
        unsigned int v;
        SRef const s(prevPos+1,curPos);
        istringstream is(std::string(s.begin,s.length()));
        is >> oct >> v;
        if (is.fail() || v>std::numeric_limits<unsigned char>::max()) {
            syntaxError(curPos, "Invalid character code");
        }
        outString.push_back(static_cast<unsigned char>(v));
        continue;
    }
yy17:
        ++curPos;
        { outString.push_back('\077'); continue; }
yy19:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy38;
        default:        goto yy20;
        }
yy20:
        curPos = marker;
        goto yy10;
yy21:
        ++curPos;
        { outString.push_back('\134'); continue; }
yy23:
        ++curPos;
        { outString.push_back('\007'); continue; }
yy25:
        ++curPos;
        { outString.push_back('\010'); continue; }
yy27:
        ++curPos;
        { outString.push_back('\006'); continue; }
yy29:
        ++curPos;
        { outString.push_back('\012'); continue; }
yy31:
        ++curPos;
        { outString.push_back('\015'); continue; }
yy33:
        ++curPos;
        { outString.push_back('\011'); continue; }
yy35:
        ++curPos;
        { outString.push_back('\013'); continue; }
yy37:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':        goto yy40;
        default:        goto yy16;
        }
yy38:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy41;
        default:        goto yy39;
        }
yy39:
        {
        unsigned int v;
        SRef const s(prevPos+2,curPos);
        istringstream is(std::string(s.begin,s.length()));
        is >> hex >> v;
        if (is.fail() || v>std::numeric_limits<unsigned char>::max()) {
            syntaxError(curPos, "Invalid character code");
        }
        outString.push_back(static_cast<unsigned char>(v));
        continue;
    }
yy40:
        ++curPos;
        goto yy16;
yy41:
        ++curPos;
        goto yy39;
}

    }
}

ETokens Scanner::scanModifier(EScanContext ctx, Scanner::Token &t)
{
    const char* &curPos = t.m_text.end;
    int &brigId = t.m_brigId;
    const char *marker = NULL;
    const char *ctxMarker = NULL;

{
    char yych;
    unsigned int yyaccept = 0;
    yych = *(marker = curPos);
    switch (yych) {
    case '_':    goto yy45;
    default:    goto yy44;
    }
yy44:
    { brigId = 0; return EMNone; }
yy45:
    yych = *++curPos;
    switch (yych) {
    case '1':    goto yy47;
    case '2':    goto yy48;
    case '3':    goto yy49;
    case 'a':    goto yy50;
    case 'b':    goto yy51;
    case 'c':    goto yy52;
    case 'd':    goto yy53;
    case 'e':    goto yy54;
    case 'f':    goto yy55;
    case 'g':    goto yy56;
    case 'h':    goto yy57;
    case 'k':    goto yy58;
    case 'l':    goto yy59;
    case 'm':    goto yy60;
    case 'n':    goto yy61;
    case 'o':    goto yy62;
    case 'p':    goto yy63;
    case 'r':    goto yy64;
    case 's':    goto yy65;
    case 'u':    goto yy66;
    case 'v':    goto yy67;
    case 'w':    goto yy68;
    case 'x':    goto yy69;
    case 'z':    goto yy70;
    default:    goto yy46;
    }
yy46:
    curPos = marker;
    switch (yyaccept) {
    case 0:     goto yy44;
    case 1:     goto yy112;
    case 2:     goto yy122;
    case 3:     goto yy227;
    case 4:     goto yy231;
    case 5:     goto yy258;
    case 6:     goto yy262;
    case 7:     goto yy437;
    case 8:     goto yy529;
    case 9:     goto yy573;
    case 10:     goto yy596;
    case 11:     goto yy669;
    case 12:     goto yy693;
    case 13:     goto yy696;
    default:    goto yy706;
    }
yy47:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy71;
    default:    goto yy46;
    }
yy48:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy72;
    default:    goto yy46;
    }
yy49:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy73;
    default:    goto yy46;
    }
yy50:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy74;
    case 'g':    goto yy75;
    case 'l':    goto yy76;
    case 'n':    goto yy77;
    case 'r':    goto yy78;
    default:    goto yy46;
    }
yy51:
    yych = *++curPos;
    switch (yych) {
    case '1':    goto yy79;
    case '3':    goto yy80;
    case '6':    goto yy81;
    case '8':    goto yy82;
    default:    goto yy46;
    }
yy52:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy83;
    case 'h':    goto yy84;
    case 'o':    goto yy85;
    default:    goto yy46;
    }
yy53:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy86;
    case 'o':    goto yy87;
    default:    goto yy46;
    }
yy54:
    yych = *++curPos;
    switch (yych) {
    case 'q':    goto yy88;
    case 'x':    goto yy89;
    default:    goto yy46;
    }
yy55:
    yych = *++curPos;
    switch (yych) {
    case '1':    goto yy90;
    case '3':    goto yy91;
    case '6':    goto yy92;
    case 'i':    goto yy93;
    case 't':    goto yy94;
    default:    goto yy46;
    }
yy56:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy95;
    case 'l':    goto yy96;
    case 'r':    goto yy97;
    case 't':    goto yy98;
    default:    goto yy46;
    }
yy57:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy99;
    default:    goto yy46;
    }
yy58:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy100;
    default:    goto yy46;
    }
yy59:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy101;
    case 'e':    goto yy102;
    case 't':    goto yy103;
    default:    goto yy46;
    }
yy60:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy104;
    case 'i':    goto yy105;
    default:    goto yy46;
    }
yy61:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy106;
    case 'e':    goto yy107;
    case 'o':    goto yy108;
    case 'u':    goto yy109;
    default:    goto yy46;
    }
yy62:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy110;
    default:    goto yy46;
    }
yy63:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'q':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy113;
    case 'p':    goto yy114;
    case 'r':    goto yy115;
    case 's':    goto yy116;
    default:    goto yy111;
    }
yy64:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy117;
    case 'l':    goto yy118;
    case 'o':    goto yy119;
    case 'w':    goto yy120;
    default:    goto yy46;
    }
yy65:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '2':
    case '4':
    case '5':
    case '7':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'b':
    case 'f':
    case 'h':
    case 'j':
    case 'k':
    case 'm':
    case 'o':
    case 'q':
    case 'r':
    case 'v':
    case 'w':
    case 'x':    goto yy46;
    case '1':    goto yy123;
    case '3':    goto yy124;
    case '6':    goto yy125;
    case '8':    goto yy126;
    case '_':    goto yy127;
    case 'a':    goto yy128;
    case 'c':    goto yy129;
    case 'd':    goto yy130;
    case 'e':    goto yy131;
    case 'g':    goto yy132;
    case 'i':    goto yy133;
    case 'l':    goto yy134;
    case 'n':    goto yy135;
    case 'p':    goto yy136;
    case 's':    goto yy137;
    case 't':    goto yy138;
    case 'u':    goto yy139;
    case 'y':    goto yy140;
    case 'z':    goto yy141;
    default:    goto yy121;
    }
yy66:
    yych = *++curPos;
    switch (yych) {
    case '1':    goto yy142;
    case '3':    goto yy143;
    case '6':    goto yy144;
    case '8':    goto yy145;
    case 'p':    goto yy146;
    default:    goto yy46;
    }
yy67:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy147;
    case '3':    goto yy148;
    case '4':    goto yy149;
    default:    goto yy46;
    }
yy68:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy150;
    case 'g':    goto yy151;
    case 'i':    goto yy152;
    case 'o':    goto yy153;
    case 'r':    goto yy154;
    default:    goto yy46;
    }
yy69:
    yych = *++curPos;
    switch (yych) {
    case 'o':    goto yy155;
    default:    goto yy46;
    }
yy70:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy156;
    default:    goto yy46;
    }
yy71:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'a':    goto yy159;
    case 'b':    goto yy160;
    default:    goto yy157;
    }
yy72:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'b':
    case 'c':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'a':    goto yy163;
    case 'd':    goto yy164;
    default:    goto yy161;
    }
yy73:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy165;
    }
yy74:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy167;
    default:    goto yy46;
    }
yy75:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy168;
    default:    goto yy46;
    }
yy76:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy169;
    default:    goto yy46;
    }
yy77:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy170;
    default:    goto yy46;
    }
yy78:
    yych = *++curPos;
    switch (yych) {
    case 'g':    goto yy171;
    case 'r':    goto yy172;
    default:    goto yy46;
    }
yy79:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '3':
    case '4':
    case '5':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '2':    goto yy175;
    case '6':    goto yy176;
    default:    goto yy173;
    }
yy80:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy177;
    default:    goto yy46;
    }
yy81:
    yych = *++curPos;
    switch (yych) {
    case '4':    goto yy178;
    default:    goto yy46;
    }
yy82:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy179;
    }
yy83:
    yych = *++curPos;
    switch (yych) {
    case 's':    goto yy181;
    default:    goto yy46;
    }
yy84:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy182;
    default:    goto yy46;
    }
yy85:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy183;
    case 'o':    goto yy184;
    default:    goto yy46;
    }
yy86:
    yych = *++curPos;
    switch (yych) {
    case 'p':    goto yy185;
    default:    goto yy46;
    }
yy87:
    yych = *++curPos;
    switch (yych) {
    case 'w':    goto yy186;
    default:    goto yy46;
    }
yy88:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy189;
    default:    goto yy187;
    }
yy89:
    yych = *++curPos;
    switch (yych) {
    case 'c':    goto yy190;
    default:    goto yy46;
    }
yy90:
    yych = *++curPos;
    switch (yych) {
    case '6':    goto yy191;
    default:    goto yy46;
    }
yy91:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy192;
    default:    goto yy46;
    }
yy92:
    yych = *++curPos;
    switch (yych) {
    case '4':    goto yy193;
    default:    goto yy46;
    }
yy93:
    yych = *++curPos;
    switch (yych) {
    case 'l':    goto yy194;
    default:    goto yy46;
    }
yy94:
    yych = *++curPos;
    switch (yych) {
    case 'z':    goto yy195;
    default:    goto yy46;
    }
yy95:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy198;
    default:    goto yy196;
    }
yy96:
    yych = *++curPos;
    switch (yych) {
    case 'o':    goto yy199;
    default:    goto yy46;
    }
yy97:
    yych = *++curPos;
    switch (yych) {
    case 'o':    goto yy200;
    default:    goto yy46;
    }
yy98:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy203;
    default:    goto yy201;
    }
yy99:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy204;
    default:    goto yy46;
    }
yy100:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy205;
    default:    goto yy46;
    }
yy101:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy206;
    }
yy102:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy210;
    default:    goto yy208;
    }
yy103:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy213;
    default:    goto yy211;
    }
yy104:
    yych = *++curPos;
    switch (yych) {
    case 'x':    goto yy214;
    default:    goto yy46;
    }
yy105:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy215;
    default:    goto yy46;
    }
yy106:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy216;
    default:    goto yy46;
    }
yy107:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'a':    goto yy219;
    case 'u':    goto yy220;
    default:    goto yy217;
    }
yy108:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy221;
    default:    goto yy46;
    }
yy109:
    yych = *++curPos;
    switch (yych) {
    case 'm':    goto yy222;
    default:    goto yy46;
    }
yy110:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy223;
    }
yy111:
    ++curPos;
yy112:
    curPos -= 1;
    { brigId = BRIG_PACK_P; return EMPacking;  }
yy113:
    yyaccept = 1;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy225;
    default:    goto yy112;
    }
yy114:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy228;
    default:    goto yy226;
    }
yy115:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy229;
    default:    goto yy46;
    }
yy116:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy232;
    default:    goto yy230;
    }
yy117:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy233;
    default:    goto yy46;
    }
yy118:
    yych = *++curPos;
    switch (yych) {
    case 'x':    goto yy234;
    default:    goto yy46;
    }
yy119:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy235;
    default:    goto yy46;
    }
yy120:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy236;
    default:    goto yy46;
    }
yy121:
    ++curPos;
yy122:
    curPos -= 1;
    { brigId = BRIG_PACK_S; return EMPacking;  }
yy123:
    yych = *++curPos;
    switch (yych) {
    case '6':    goto yy237;
    default:    goto yy46;
    }
yy124:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy238;
    default:    goto yy46;
    }
yy125:
    yych = *++curPos;
    switch (yych) {
    case '4':    goto yy239;
    default:    goto yy46;
    }
yy126:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy242;
    default:    goto yy240;
    }
yy127:
    yyaccept = 2;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy243;
    default:    goto yy122;
    }
yy128:
    yych = *++curPos;
    switch (yych) {
    case 'm':    goto yy244;
    default:    goto yy46;
    }
yy129:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy245;
    case 'r':    goto yy246;
    default:    goto yy46;
    }
yy130:
    yych = *++curPos;
    switch (yych) {
    case 'o':    goto yy247;
    default:    goto yy46;
    }
yy131:
    yych = *++curPos;
    switch (yych) {
    case 'q':    goto yy248;
    default:    goto yy46;
    }
yy132:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy249;
    case 't':    goto yy250;
    default:    goto yy46;
    }
yy133:
    yych = *++curPos;
    switch (yych) {
    case 'g':    goto yy251;
    default:    goto yy46;
    }
yy134:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy252;
    case 't':    goto yy253;
    default:    goto yy46;
    }
yy135:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy254;
    case 'e':    goto yy255;
    case 'u':    goto yy256;
    default:    goto yy46;
    }
yy136:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy259;
    case 'i':    goto yy260;
    default:    goto yy257;
    }
yy137:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy263;
    default:    goto yy261;
    }
yy138:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy264;
    }
yy139:
    yych = *++curPos;
    switch (yych) {
    case 'b':    goto yy266;
    case 'p':    goto yy267;
    default:    goto yy46;
    }
yy140:
    yych = *++curPos;
    switch (yych) {
    case 's':    goto yy268;
    default:    goto yy46;
    }
yy141:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy269;
    default:    goto yy46;
    }
yy142:
    yych = *++curPos;
    switch (yych) {
    case '6':    goto yy270;
    default:    goto yy46;
    }
yy143:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy271;
    default:    goto yy46;
    }
yy144:
    yych = *++curPos;
    switch (yych) {
    case '4':    goto yy272;
    default:    goto yy46;
    }
yy145:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy275;
    default:    goto yy273;
    }
yy146:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'i':    goto yy278;
    default:    goto yy276;
    }
yy147:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy279;
    }
yy148:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy281;
    }
yy149:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy283;
    }
yy150:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy285;
    case 'v':    goto yy286;
    default:    goto yy46;
    }
yy151:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy287;
    }
yy152:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy289;
    default:    goto yy46;
    }
yy153:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy290;
    default:    goto yy46;
    }
yy154:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy291;
    default:    goto yy46;
    }
yy155:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy292;
    default:    goto yy46;
    }
yy156:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy293;
    default:    goto yy46;
    }
yy157:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_GEOMETRY_1D;  return EMGeom; }
yy159:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy294;
    }
yy160:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy296;
    }
yy161:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_GEOMETRY_2D;  return EMGeom; }
yy163:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'd':    goto yy300;
    default:    goto yy298;
    }
yy164:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy301;
    default:    goto yy46;
    }
yy165:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_GEOMETRY_3D;  return EMGeom; }
yy167:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'r':    goto yy304;
    default:    goto yy302;
    }
yy168:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy305;
    default:    goto yy46;
    }
yy169:
    yych = *++curPos;
    switch (yych) {
    case 'g':    goto yy306;
    default:    goto yy46;
    }
yy170:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy307;
    }
yy171:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy309;
    }
yy172:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy311;
    default:    goto yy46;
    }
yy173:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_B1; return EMType;    }
yy175:
    yych = *++curPos;
    switch (yych) {
    case '8':    goto yy312;
    default:    goto yy46;
    }
yy176:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy313;
    }
yy177:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy315;
    }
yy178:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy317;
    }
yy179:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_B8; return EMType;    }
yy181:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy319;
    }
yy182:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy321;
    default:    goto yy46;
    }
yy183:
    yych = *++curPos;
    switch (yych) {
    case 's':    goto yy322;
    default:    goto yy46;
    }
yy184:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy323;
    default:    goto yy46;
    }
yy185:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy324;
    default:    goto yy46;
    }
yy186:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy325;
    default:    goto yy46;
    }
yy187:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_EQ; return EMCompare; }
yy189:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'i':    goto yy328;
    default:    goto yy326;
    }
yy190:
    yych = *++curPos;
    switch (yych) {
    case 'h':    goto yy329;
    default:    goto yy46;
    }
yy191:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy332;
    default:    goto yy330;
    }
yy192:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy335;
    default:    goto yy333;
    }
yy193:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy338;
    default:    goto yy336;
    }
yy194:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy339;
    default:    goto yy46;
    }
yy195:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy340;
    }
yy196:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_GE; return EMCompare; }
yy198:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy342;
    }
yy199:
    yych = *++curPos;
    switch (yych) {
    case 'b':    goto yy344;
    default:    goto yy46;
    }
yy200:
    yych = *++curPos;
    switch (yych) {
    case 'u':    goto yy345;
    default:    goto yy46;
    }
yy201:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_GT; return EMCompare; }
yy203:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy346;
    }
yy204:
    yych = *++curPos;
    switch (yych) {
    case 'g':    goto yy348;
    default:    goto yy46;
    }
yy205:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy349;
    default:    goto yy46;
    }
yy206:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_LD; return EMAtomicOp;
	default: return EEmpty; } }
yy208:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_LE; return EMCompare; }
yy210:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy350;
    }
yy211:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_LT; return EMCompare; }
yy213:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy352;
    }
yy214:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy354;
    }
yy215:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy356;
    }
yy216:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy358;
    }
yy217:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_NE; return EMCompare; }
yy219:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy360;
    default:    goto yy46;
    }
yy220:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy361;
    }
yy221:
    yych = *++curPos;
    switch (yych) {
    case 'u':    goto yy363;
    default:    goto yy46;
    }
yy222:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy364;
    }
yy223:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_OR; return EMAtomicOp;
	default: return EEmpty; } }
yy225:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy366;
    default:    goto yy46;
    }
yy226:
    ++curPos;
yy227:
    curPos -= 1;
    { brigId = BRIG_PACK_PP; return EMPacking; }
yy228:
    yyaccept = 3;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy367;
    default:    goto yy227;
    }
yy229:
    yych = *++curPos;
    switch (yych) {
    case 'v':    goto yy368;
    default:    goto yy46;
    }
yy230:
    ++curPos;
yy231:
    curPos -= 1;
    { brigId = BRIG_PACK_PS; return EMPacking; }
yy232:
    yyaccept = 4;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy369;
    default:    goto yy231;
    }
yy233:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy370;
    default:    goto yy46;
    }
yy234:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy371;
    }
yy235:
    yych = *++curPos;
    switch (yych) {
    case 'm':    goto yy373;
    default:    goto yy46;
    }
yy236:
    yych = *++curPos;
    switch (yych) {
    case 'm':    goto yy374;
    default:    goto yy46;
    }
yy237:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy377;
    default:    goto yy375;
    }
yy238:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy380;
    default:    goto yy378;
    }
yy239:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy383;
    default:    goto yy381;
    }
yy240:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S8; return EMType;    }
yy242:
    yych = *++curPos;
    switch (yych) {
    case '1':    goto yy384;
    case '4':    goto yy385;
    case '8':    goto yy386;
    default:    goto yy46;
    }
yy243:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy387;
    default:    goto yy46;
    }
yy244:
    yych = *++curPos;
    switch (yych) {
    case 'p':    goto yy388;
    default:    goto yy46;
    }
yy245:
    yych = *++curPos;
    switch (yych) {
    case 'c':    goto yy389;
    case 'r':    goto yy390;
    default:    goto yy46;
    }
yy246:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy391;
    default:    goto yy46;
    }
yy247:
    yych = *++curPos;
    switch (yych) {
    case 'w':    goto yy392;
    default:    goto yy46;
    }
yy248:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy395;
    default:    goto yy393;
    }
yy249:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy398;
    default:    goto yy396;
    }
yy250:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy401;
    default:    goto yy399;
    }
yy251:
    yych = *++curPos;
    switch (yych) {
    case '3':    goto yy402;
    case '6':    goto yy403;
    default:    goto yy46;
    }
yy252:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy406;
    default:    goto yy404;
    }
yy253:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'u':    goto yy409;
    default:    goto yy407;
    }
yy254:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy410;
    default:    goto yy46;
    }
yy255:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'a':    goto yy413;
    case 'u':    goto yy414;
    default:    goto yy411;
    }
yy256:
    yych = *++curPos;
    switch (yych) {
    case 'm':    goto yy415;
    default:    goto yy46;
    }
yy257:
    ++curPos;
yy258:
    curPos -= 1;
    { brigId = BRIG_PACK_SP; return EMPacking; }
yy259:
    yyaccept = 5;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy416;
    default:    goto yy258;
    }
yy260:
    yych = *++curPos;
    switch (yych) {
    case 'l':    goto yy417;
    default:    goto yy46;
    }
yy261:
    ++curPos;
yy262:
    curPos -= 1;
    { brigId = BRIG_PACK_SS; return EMPacking; }
yy263:
    yyaccept = 6;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy418;
    default:    goto yy262;
    }
yy264:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_ST; return EMAtomicOp;
	default: return EEmpty; } }
yy266:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy419;
    }
yy267:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy421;
    default:    goto yy46;
    }
yy268:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy422;
    default:    goto yy46;
    }
yy269:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy423;
    default:    goto yy46;
    }
yy270:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy426;
    default:    goto yy424;
    }
yy271:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy429;
    default:    goto yy427;
    }
yy272:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'y':
    case 'z':    goto yy46;
    case 'x':    goto yy432;
    default:    goto yy430;
    }
yy273:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U8; return EMType;    }
yy275:
    yych = *++curPos;
    switch (yych) {
    case '1':    goto yy433;
    case '4':    goto yy434;
    case '8':    goto yy435;
    default:    goto yy46;
    }
yy276:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_FLOAT_PLUS_INFINITY; return EMRound; }
yy278:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy438;
    default:    goto yy436;
    }
yy279:
    ++curPos;
    curPos -= 1;
    { brigId = 2; return EMVector; }
yy281:
    ++curPos;
    curPos -= 1;
    { brigId = 3; return EMVector; }
yy283:
    ++curPos;
    curPos -= 1;
    { brigId = 4; return EMVector; }
yy285:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy439;
    default:    goto yy46;
    }
yy286:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy440;
    default:    goto yy46;
    }
yy287:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_MEMORY_SCOPE_WORKGROUP; return EMMemoryScope; }
yy289:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy441;
    default:    goto yy46;
    }
yy290:
    yych = *++curPos;
    switch (yych) {
    case 'm':    goto yy442;
    default:    goto yy46;
    }
yy291:
    yych = *++curPos;
    switch (yych) {
    case 'p':    goto yy443;
    default:    goto yy46;
    }
yy292:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy444;
    }
yy293:
    yych = *++curPos;
    switch (yych) {
    case 'o':    goto yy446;
    default:    goto yy46;
    }
yy294:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_GEOMETRY_1DA; return EMGeom; }
yy296:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_GEOMETRY_1DB; return EMGeom; }
yy298:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_GEOMETRY_2DA; return EMGeom; }
yy300:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy447;
    default:    goto yy46;
    }
yy301:
    yych = *++curPos;
    switch (yych) {
    case 'p':    goto yy448;
    default:    goto yy46;
    }
yy302:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_ADD; return EMAtomicOp;
	default: return EEmpty; } }
yy304:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy449;
    default:    goto yy46;
    }
yy305:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy450;
    default:    goto yy46;
    }
yy306:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy451;
    default:    goto yy46;
    }
yy307:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_AND; return EMAtomicOp;
	default: return EEmpty; } }
yy309:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierContext: brigId = BRIG_SEGMENT_ARG; return EMSegment;
	default: return EEmpty; } }
yy311:
    yych = *++curPos;
    switch (yych) {
    case 'y':    goto yy452;
    default:    goto yy46;
    }
yy312:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy453;
    }
yy313:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_B16; return EMType;   }
yy315:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_B32; return EMType;   }
yy317:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_B64; return EMType;   }
yy319:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_CAS; return EMAtomicOp;
	default: return EEmpty; } }
yy321:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy455;
    default:    goto yy46;
    }
yy322:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy456;
    default:    goto yy46;
    }
yy323:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy457;
    default:    goto yy46;
    }
yy324:
    yych = *++curPos;
    switch (yych) {
    case 'h':    goto yy458;
    default:    goto yy46;
    }
yy325:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'i':    goto yy461;
    default:    goto yy459;
    }
yy326:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_EQU; return EMCompare; }
yy328:
    yych = *++curPos;
    switch (yych) {
    case 'v':    goto yy462;
    default:    goto yy46;
    }
yy329:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy463;
    }
yy330:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_F16; return EMType;   }
yy332:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy465;
    case '4':    goto yy466;
    case '8':    goto yy467;
    default:    goto yy46;
    }
yy333:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_F32; return EMType;   }
yy335:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy468;
    case '4':    goto yy469;
    default:    goto yy46;
    }
yy336:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_F64; return EMType;   }
yy338:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy470;
    default:    goto yy46;
    }
yy339:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy471;
    default:    goto yy46;
    }
yy340:
    ++curPos;
    curPos -= 1;
    { brigId = 0; return EMFTZ;    }
yy342:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_GEU; return EMCompare; }
yy344:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy472;
    default:    goto yy46;
    }
yy345:
    yych = *++curPos;
    switch (yych) {
    case 'p':    goto yy473;
    default:    goto yy46;
    }
yy346:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_GTU; return EMCompare; }
yy348:
    yych = *++curPos;
    switch (yych) {
    case 'h':    goto yy474;
    default:    goto yy46;
    }
yy349:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy475;
    default:    goto yy46;
    }
yy350:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_LEU; return EMCompare; }
yy352:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_LTU; return EMCompare; }
yy354:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_MAX; return EMAtomicOp;
	default: return EEmpty; } }
yy356:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_MIN; return EMAtomicOp;
	default: return EEmpty; } }
yy358:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_NAN; return EMCompare; }
yy360:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'i':    goto yy478;
    default:    goto yy476;
    }
yy361:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_NEU; return EMCompare; }
yy363:
    yych = *++curPos;
    switch (yych) {
    case 'l':    goto yy479;
    default:    goto yy46;
    }
yy364:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_NUM; return EMCompare; }
yy366:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy480;
    default:    goto yy46;
    }
yy367:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy481;
    default:    goto yy46;
    }
yy368:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy482;
    default:    goto yy46;
    }
yy369:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy483;
    default:    goto yy46;
    }
yy370:
    yych = *++curPos;
    switch (yych) {
    case 'o':    goto yy484;
    default:    goto yy46;
    }
yy371:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_MEMORY_ORDER_RELAXED; return EMMemoryOrder; }
yy373:
    yych = *++curPos;
    switch (yych) {
    case 'g':    goto yy485;
    default:    goto yy46;
    }
yy374:
    yych = *++curPos;
    switch (yych) {
    case 'g':    goto yy486;
    default:    goto yy46;
    }
yy375:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S16; return EMType;   }
yy377:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy487;
    case '4':    goto yy488;
    case '8':    goto yy489;
    default:    goto yy46;
    }
yy378:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S32; return EMType;   }
yy380:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy490;
    case '4':    goto yy491;
    default:    goto yy46;
    }
yy381:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S64; return EMType;   }
yy383:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy492;
    default:    goto yy46;
    }
yy384:
    yych = *++curPos;
    switch (yych) {
    case '6':    goto yy493;
    default:    goto yy46;
    }
yy385:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy494;
    }
yy386:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy496;
    }
yy387:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy498;
    default:    goto yy46;
    }
yy388:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy499;
    }
yy389:
    yych = *++curPos;
    switch (yych) {
    case 'q':    goto yy501;
    default:    goto yy46;
    }
yy390:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy502;
    }
yy391:
    yych = *++curPos;
    switch (yych) {
    case 'l':    goto yy504;
    default:    goto yy46;
    }
yy392:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy505;
    default:    goto yy46;
    }
yy393:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SEQ; return EMCompare; }
yy395:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy506;
    }
yy396:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SGE; return EMCompare; }
yy398:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy508;
    }
yy399:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SGT; return EMCompare; }
yy401:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy510;
    }
yy402:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy512;
    default:    goto yy46;
    }
yy403:
    yych = *++curPos;
    switch (yych) {
    case '4':    goto yy513;
    default:    goto yy46;
    }
yy404:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SLE; return EMCompare; }
yy406:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy514;
    }
yy407:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SLT; return EMCompare; }
yy409:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy516;
    }
yy410:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy518;
    }
yy411:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SNE; return EMCompare; }
yy413:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy520;
    default:    goto yy46;
    }
yy414:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy521;
    }
yy415:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy523;
    }
yy416:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy525;
    default:    goto yy46;
    }
yy417:
    yych = *++curPos;
    switch (yych) {
    case 'l':    goto yy526;
    default:    goto yy46;
    }
yy418:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy527;
    default:    goto yy46;
    }
yy419:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_SUB; return EMAtomicOp;
	default: return EEmpty; } }
yy421:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy530;
    default:    goto yy528;
    }
yy422:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy531;
    default:    goto yy46;
    }
yy423:
    yych = *++curPos;
    switch (yych) {
    case 'o':    goto yy532;
    default:    goto yy46;
    }
yy424:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U16; return EMType;   }
yy426:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy533;
    case '4':    goto yy534;
    case '8':    goto yy535;
    default:    goto yy46;
    }
yy427:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U32; return EMType;   }
yy429:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy536;
    case '4':    goto yy537;
    default:    goto yy46;
    }
yy430:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U64; return EMType;   }
yy432:
    yych = *++curPos;
    switch (yych) {
    case '2':    goto yy538;
    default:    goto yy46;
    }
yy433:
    yych = *++curPos;
    switch (yych) {
    case '6':    goto yy539;
    default:    goto yy46;
    }
yy434:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy540;
    }
yy435:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy542;
    }
yy436:
    ++curPos;
yy437:
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_PLUS_INFINITY; return EMRound; }
yy438:
    yyaccept = 7;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy544;
    default:    goto yy437;
    }
yy439:
    yych = *++curPos;
    switch (yych) {
    case '_':    goto yy545;
    case 't':    goto yy546;
    default:    goto yy46;
    }
yy440:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy547;
    }
yy441:
    yych = *++curPos;
    switch (yych) {
    case 'h':    goto yy549;
    default:    goto yy46;
    }
yy442:
    yych = *++curPos;
    switch (yych) {
    case 'g':    goto yy550;
    default:    goto yy46;
    }
yy443:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy551;
    case 'i':    goto yy552;
    default:    goto yy46;
    }
yy444:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_XOR; return EMAtomicOp;
	default: return EEmpty; } }
yy446:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case 'i':    goto yy555;
    default:    goto yy553;
    }
yy447:
    yych = *++curPos;
    switch (yych) {
    case 'p':    goto yy556;
    default:    goto yy46;
    }
yy448:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy557;
    default:    goto yy46;
    }
yy449:
    yych = *++curPos;
    switch (yych) {
    case 's':    goto yy558;
    default:    goto yy46;
    }
yy450:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy559;
    }
yy451:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy561;
    }
yy452:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy563;
    }
yy453:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_B128; return EMType;  }
yy455:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy565;
    default:    goto yy46;
    }
yy456:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy566;
    }
yy457:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy568;
    }
yy458:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy570;
    }
yy459:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_FLOAT_MINUS_INFINITY; return EMRound; }
yy461:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy574;
    default:    goto yy572;
    }
yy462:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy575;
    }
yy463:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_EXCH; return EMAtomicOp;
	default: return EEmpty; } }
yy465:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy577;
    }
yy466:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy579;
    }
yy467:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy581;
    }
yy468:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy583;
    }
yy469:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy585;
    }
yy470:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy587;
    }
yy471:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy589;
    default:    goto yy46;
    }
yy472:
    yych = *++curPos;
    switch (yych) {
    case 'l':    goto yy590;
    default:    goto yy46;
    }
yy473:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy591;
    }
yy474:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy593;
    default:    goto yy46;
    }
yy475:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy594;
    default:    goto yy46;
    }
yy476:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_FLOAT_NEAR_EVEN; return EMRound; }
yy478:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy597;
    default:    goto yy595;
    }
yy479:
    yych = *++curPos;
    switch (yych) {
    case 'l':    goto yy598;
    default:    goto yy46;
    }
yy480:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy599;
    }
yy481:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy601;
    default:    goto yy46;
    }
yy482:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy602;
    default:    goto yy46;
    }
yy483:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy603;
    default:    goto yy46;
    }
yy484:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy604;
    default:    goto yy46;
    }
yy485:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy605;
    }
yy486:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy607;
    }
yy487:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy609;
    }
yy488:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy611;
    }
yy489:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy613;
    }
yy490:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy615;
    }
yy491:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy617;
    }
yy492:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy619;
    }
yy493:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy621;
    }
yy494:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S8X4; return EMType;  }
yy496:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S8X8; return EMType;  }
yy498:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy623;
    }
yy499:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_SAMP; return EMType;  }
yy501:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy625;
    }
yy502:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_MEMORY_ORDER_SC_ACQUIRE_RELEASE; return EMMemoryOrder; }
yy504:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy627;
    }
yy505:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy629;
    default:    goto yy46;
    }
yy506:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SEQU; return EMCompare; }
yy508:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SGEU; return EMCompare; }
yy510:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SGTU; return EMCompare; }
yy512:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy630;
    }
yy513:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy632;
    }
yy514:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SLEU; return EMCompare; }
yy516:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SLTU; return EMCompare; }
yy518:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SNAN; return EMCompare; }
yy520:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy634;
    default:    goto yy46;
    }
yy521:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SNEU; return EMCompare; }
yy523:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_COMPARE_SNUM; return EMCompare; }
yy525:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy635;
    default:    goto yy46;
    }
yy526:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy636;
    }
yy527:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy638;
    default:    goto yy46;
    }
yy528:
    ++curPos;
yy529:
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_SIGNALING_PLUS_INFINITY; return EMRound; }
yy530:
    yyaccept = 8;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy639;
    default:    goto yy529;
    }
yy531:
    yych = *++curPos;
    switch (yych) {
    case 'm':    goto yy640;
    default:    goto yy46;
    }
yy532:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy641;
    default:    goto yy46;
    }
yy533:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy642;
    }
yy534:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy644;
    }
yy535:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy646;
    }
yy536:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy648;
    }
yy537:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy650;
    }
yy538:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy652;
    }
yy539:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy654;
    }
yy540:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U8X4; return EMType;  }
yy542:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U8X8; return EMType;  }
yy544:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy656;
    default:    goto yy46;
    }
yy545:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy657;
    case 'g':    goto yy658;
    case 'l':    goto yy659;
    case 'n':    goto yy660;
    default:    goto yy46;
    }
yy546:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy661;
    default:    goto yy46;
    }
yy547:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_MEMORY_SCOPE_WAVEFRONT; return EMMemoryScope; }
yy549:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy662;
    }
yy550:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy664;
    }
yy551:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy666;
    default:    goto yy46;
    }
yy552:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy667;
    default:    goto yy46;
    }
yy553:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_FLOAT_ZERO; return EMRound; }
yy555:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy670;
    default:    goto yy668;
    }
yy556:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy671;
    default:    goto yy46;
    }
yy557:
    yych = *++curPos;
    switch (yych) {
    case 'h':    goto yy672;
    default:    goto yy46;
    }
yy558:
    yych = *++curPos;
    switch (yych) {
    case 's':    goto yy673;
    default:    goto yy46;
    }
yy559:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_MEMORY_SCOPE_AGENT; return EMMemoryScope; }
yy561:
    ++curPos;
    curPos -= 1;
    { brigId = 0; return EMAlign;  }
yy563:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_IMAGE_QUERY_ARRAY;        return EMImageQuery; }
yy565:
    yych = *++curPos;
    switch (yych) {
    case 'l':    goto yy674;
    default:    goto yy46;
    }
yy566:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_MEMORY_CONST;      return EMConst;   }
yy568:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_SAMPLER_QUERY_COORD; return EMSamplerQuery; }
yy570:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_IMAGE_QUERY_DEPTH;        return EMImageQuery; }
yy572:
    ++curPos;
yy573:
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_MINUS_INFINITY; return EMRound; }
yy574:
    yyaccept = 9;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy675;
    default:    goto yy573;
    }
yy575:
    ++curPos;
    curPos -= 1;
    { brigId = 0; return EMEquiv;  }
yy577:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_F16X2; return EMType; }
yy579:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_F16X4; return EMType; }
yy581:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_F16X8; return EMType; }
yy583:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_F32X2; return EMType; }
yy585:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_F32X4; return EMType; }
yy587:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_F64X2; return EMType; }
yy589:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy676;
    }
yy590:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy678;
    }
yy591:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierContext: brigId = BRIG_SEGMENT_GROUP; return EMSegment;
	default: return EEmpty; } }
yy593:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy680;
    }
yy594:
    yych = *++curPos;
    switch (yych) {
    case 'g':    goto yy682;
    default:    goto yy46;
    }
yy595:
    ++curPos;
yy596:
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_NEAR_EVEN; return EMRound; }
yy597:
    yyaccept = 10;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy683;
    default:    goto yy596;
    }
yy598:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy684;
    }
yy599:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_PACK_PSAT; return EMPacking; }
yy601:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy686;
    }
yy602:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy688;
    default:    goto yy46;
    }
yy603:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy689;
    }
yy604:
    yych = *++curPos;
    switch (yych) {
    case 'l':    goto yy691;
    default:    goto yy46;
    }
yy605:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_ROIMG; return EMType; }
yy607:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_RWIMG; return EMType; }
yy609:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S16X2; return EMType; }
yy611:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S16X4; return EMType; }
yy613:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S16X8; return EMType; }
yy615:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S32X2; return EMType; }
yy617:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S32X4; return EMType; }
yy619:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S64X2; return EMType; }
yy621:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_S8X16; return EMType; }
yy623:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_PACK_SSAT; return EMPacking; }
yy625:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_MEMORY_ORDER_SC_ACQUIRE; return EMMemoryOrder; }
yy627:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_MEMORY_ORDER_SC_RELEASE; return EMMemoryOrder; }
yy629:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy694;
    default:    goto yy692;
    }
yy630:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_SIG32; return EMType; }
yy632:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_SIG64; return EMType; }
yy634:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy697;
    default:    goto yy695;
    }
yy635:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy698;
    }
yy636:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierContext: brigId = BRIG_SEGMENT_SPILL; return EMSegment;
	default: return EEmpty; } }
yy638:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy700;
    }
yy639:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy702;
    default:    goto yy46;
    }
yy640:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy703;
    }
yy641:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    case '_':    goto yy707;
    default:    goto yy705;
    }
yy642:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U16X2; return EMType; }
yy644:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U16X4; return EMType; }
yy646:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U16X8; return EMType; }
yy648:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U32X2; return EMType; }
yy650:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U32X4; return EMType; }
yy652:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U64X2; return EMType; }
yy654:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_U8X16; return EMType; }
yy656:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy708;
    default:    goto yy46;
    }
yy657:
    yych = *++curPos;
    switch (yych) {
    case 'q':    goto yy709;
    default:    goto yy46;
    }
yy658:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy710;
    default:    goto yy46;
    }
yy659:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy711;
    default:    goto yy46;
    }
yy660:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy712;
    default:    goto yy46;
    }
yy661:
    yych = *++curPos;
    switch (yych) {
    case 'm':    goto yy713;
    default:    goto yy46;
    }
yy662:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
                      case EInstModifierInstQueryContext: brigId = BRIG_IMAGE_QUERY_WIDTH; return EMImageQuery;
                      default:                            brigId = 0;                            return EMWidth;
                      }
                    }
yy664:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_TYPE_WOIMG; return EMType; }
yy666:
    yych = *++curPos;
    switch (yych) {
    case 'c':    goto yy714;
    default:    goto yy46;
    }
yy667:
    yych = *++curPos;
    switch (yych) {
    case 'c':    goto yy715;
    default:    goto yy46;
    }
yy668:
    ++curPos;
yy669:
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_ZERO; return EMRound; }
yy670:
    yyaccept = 11;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy716;
    default:    goto yy669;
    }
yy671:
    yych = *++curPos;
    switch (yych) {
    case 'h':    goto yy717;
    default:    goto yy46;
    }
yy672:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy718;
    }
yy673:
    yych = *++curPos;
    switch (yych) {
    case 'i':    goto yy720;
    default:    goto yy46;
    }
yy674:
    yych = *++curPos;
    switch (yych) {
    case 'o':    goto yy721;
    case 't':    goto yy722;
    default:    goto yy46;
    }
yy675:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy723;
    default:    goto yy46;
    }
yy676:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_SAMPLER_QUERY_FILTER; return EMSamplerQuery; }
yy678:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierContext: brigId = BRIG_SEGMENT_GLOBAL; return EMSegment;
	default: return EEmpty; } }
yy680:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_IMAGE_QUERY_HEIGHT;       return EMImageQuery; }
yy682:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy724;
    }
yy683:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy726;
    default:    goto yy46;
    }
yy684:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_SEG_CVT_NONULL;    return EMNoNull;  }
yy686:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_PACK_PPSAT; return EMPacking; }
yy688:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy727;
    }
yy689:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_PACK_PSSAT; return EMPacking; }
yy691:
    yych = *++curPos;
    switch (yych) {
    case 'y':    goto yy729;
    default:    goto yy46;
    }
yy692:
    ++curPos;
yy693:
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_SIGNALING_MINUS_INFINITY; return EMRound; }
yy694:
    yyaccept = 12;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy730;
    default:    goto yy693;
    }
yy695:
    ++curPos;
yy696:
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_SIGNALING_NEAR_EVEN; return EMRound; }
yy697:
    yyaccept = 13;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy731;
    default:    goto yy696;
    }
yy698:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_PACK_SPSAT; return EMPacking; }
yy700:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_PACK_SSSAT; return EMPacking; }
yy702:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy732;
    default:    goto yy46;
    }
yy703:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_MEMORY_SCOPE_SYSTEM; return EMMemoryScope; }
yy705:
    ++curPos;
yy706:
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_SIGNALING_ZERO; return EMRound; }
yy707:
    yyaccept = 14;
    yych = *(marker = ++curPos);
    switch (yych) {
    case 's':    goto yy733;
    default:    goto yy706;
    }
yy708:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy734;
    }
yy709:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy736;
    }
yy710:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy738;
    default:    goto yy46;
    }
yy711:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy739;
    }
yy712:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy741;
    }
yy713:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy743;
    default:    goto yy46;
    }
yy714:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy744;
    }
yy715:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy746;
    }
yy716:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy748;
    default:    goto yy46;
    }
yy717:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy749;
    }
yy718:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_GEOMETRY_2DDEPTH; return EMGeom; }
yy720:
    yych = *++curPos;
    switch (yych) {
    case 'n':    goto yy751;
    default:    goto yy46;
    }
yy721:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy752;
    default:    goto yy46;
    }
yy722:
    yych = *++curPos;
    switch (yych) {
    case 'y':    goto yy753;
    default:    goto yy46;
    }
yy723:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy754;
    default:    goto yy46;
    }
yy724:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierContext: brigId = BRIG_SEGMENT_KERNARG; return EMSegment;
	default: return EEmpty; } }
yy726:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy755;
    default:    goto yy46;
    }
yy727:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierContext: brigId = BRIG_SEGMENT_PRIVATE; return EMSegment;
	default: return EEmpty; } }
yy729:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy756;
    }
yy730:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy758;
    default:    goto yy46;
    }
yy731:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy759;
    default:    goto yy46;
    }
yy732:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy760;
    }
yy733:
    yych = *++curPos;
    switch (yych) {
    case 'a':    goto yy762;
    default:    goto yy46;
    }
yy734:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_PLUS_INFINITY_SAT; return EMRound; }
yy736:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WAIT_EQ; return EMAtomicOp;
	default: return EEmpty; } }
yy738:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy763;
    }
yy739:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WAIT_LT; return EMAtomicOp;
	default: return EEmpty; } }
yy741:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WAIT_NE; return EMAtomicOp;
	default: return EEmpty; } }
yy743:
    yych = *++curPos;
    switch (yych) {
    case 'o':    goto yy765;
    default:    goto yy46;
    }
yy744:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WRAPDEC; return EMAtomicOp;
	default: return EEmpty; } }
yy746:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WRAPINC; return EMAtomicOp;
	default: return EEmpty; } }
yy748:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy766;
    default:    goto yy46;
    }
yy749:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_GEOMETRY_2DADEPTH; return EMGeom; }
yy751:
    yych = *++curPos;
    switch (yych) {
    case 'g':    goto yy767;
    default:    goto yy46;
    }
yy752:
    yych = *++curPos;
    switch (yych) {
    case 'd':    goto yy768;
    default:    goto yy46;
    }
yy753:
    yych = *++curPos;
    switch (yych) {
    case 'p':    goto yy769;
    default:    goto yy46;
    }
yy754:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy770;
    }
yy755:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy772;
    }
yy756:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierContext: brigId = BRIG_SEGMENT_READONLY; return EMSegment;
	default: return EEmpty; } }
yy758:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy774;
    default:    goto yy46;
    }
yy759:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy775;
    default:    goto yy46;
    }
yy760:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_SIGNALING_PLUS_INFINITY_SAT; return EMRound; }
yy762:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy776;
    default:    goto yy46;
    }
yy763:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WAIT_GTE; return EMAtomicOp;
	default: return EEmpty; } }
yy765:
    yych = *++curPos;
    switch (yych) {
    case 'u':    goto yy777;
    default:    goto yy46;
    }
yy766:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy778;
    }
yy767:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy780;
    }
yy768:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy782;
    default:    goto yy46;
    }
yy769:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy783;
    default:    goto yy46;
    }
yy770:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_MINUS_INFINITY_SAT; return EMRound; }
yy772:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_NEAR_EVEN_SAT; return EMRound; }
yy774:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy784;
    }
yy775:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy786;
    }
yy776:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy788;
    }
yy777:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy790;
    default:    goto yy46;
    }
yy778:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_ZERO_SAT; return EMRound; }
yy780:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_SAMPLER_QUERY_ADDRESSING; return EMSamplerQuery; }
yy782:
    yych = *++curPos;
    switch (yych) {
    case 'r':    goto yy791;
    default:    goto yy46;
    }
yy783:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy792;
    }
yy784:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_SIGNALING_MINUS_INFINITY_SAT; return EMRound; }
yy786:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_SIGNALING_NEAR_EVEN_SAT; return EMRound; }
yy788:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_ROUND_INTEGER_SIGNALING_ZERO_SAT; return EMRound; }
yy790:
    yych = *++curPos;
    switch (yych) {
    case '_':    goto yy794;
    default:    goto yy46;
    }
yy791:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy795;
    }
yy792:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_IMAGE_QUERY_CHANNELTYPE;  return EMImageQuery; }
yy794:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy797;
    case 'g':    goto yy798;
    case 'l':    goto yy799;
    case 'n':    goto yy800;
    default:    goto yy46;
    }
yy795:
    ++curPos;
    curPos -= 1;
    { brigId = BRIG_IMAGE_QUERY_CHANNELORDER; return EMImageQuery; }
yy797:
    yych = *++curPos;
    switch (yych) {
    case 'q':    goto yy801;
    default:    goto yy46;
    }
yy798:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy802;
    default:    goto yy46;
    }
yy799:
    yych = *++curPos;
    switch (yych) {
    case 't':    goto yy803;
    default:    goto yy46;
    }
yy800:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy804;
    default:    goto yy46;
    }
yy801:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy805;
    }
yy802:
    yych = *++curPos;
    switch (yych) {
    case 'e':    goto yy807;
    default:    goto yy46;
    }
yy803:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy808;
    }
yy804:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy810;
    }
yy805:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WAITTIMEOUT_EQ; return EMAtomicOp;
	default: return EEmpty; } }
yy807:
    yych = *++curPos;
    switch (yych) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
    case 'G':
    case 'H':
    case 'I':
    case 'J':
    case 'K':
    case 'L':
    case 'M':
    case 'N':
    case 'O':
    case 'P':
    case 'Q':
    case 'R':
    case 'S':
    case 'T':
    case 'U':
    case 'V':
    case 'W':
    case 'X':
    case 'Y':
    case 'Z':
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':    goto yy46;
    default:    goto yy812;
    }
yy808:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WAITTIMEOUT_LT; return EMAtomicOp;
	default: return EEmpty; } }
yy810:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WAITTIMEOUT_NE; return EMAtomicOp;
	default: return EEmpty; } }
yy812:
    ++curPos;
    curPos -= 1;
    { switch(ctx) {
	case EInstModifierInstAtomicContext: brigId = BRIG_ATOMIC_WAITTIMEOUT_GTE; return EMAtomicOp;
	default: return EEmpty; } }
}

}

void Scanner::scanEmbeddedText(Scanner::Token &t)
{
    const char* &curPos = t.m_text.end;
    while(true) {
        const char *const prevPos = curPos;

{
        char yych;
        yych = *curPos;
        switch (yych) {
        case 0x00:        goto yy816;
        case '\n':        goto yy820;
        case '\r':        goto yy822;
        case '#':        goto yy823;
        default:        goto yy818;
        }
yy816:
        ++curPos;
        { curPos = prevPos; syntaxError(curPos, "Premature end of embedded text"); }
yy818:
        ++curPos;
yy819:
        { continue; }
yy820:
        ++curPos;
        { nextLine(curPos);
                   continue; }
yy822:
        yych = *++curPos;
        switch (yych) {
        case '\n':        goto yy820;
        default:        goto yy819;
        }
yy823:
        yych = *++curPos;
        switch (yych) {
        case '>':        goto yy824;
        default:        goto yy819;
        }
yy824:
        ++curPos;
        { break; }
}

    };
}

ETokens Scanner::scanDefault(EScanContext ctx, Scanner::Token &t)
{
    const char* &curPos = t.m_text.end;
    int &brigId = t.m_brigId;
    const char *marker = NULL;
    const char *ctxMarker = NULL;

{
        char yych;
        unsigned int yyaccept = 0;
        yych = *(marker = curPos);
        switch (yych) {
        case 0x00:        goto yy829;
        case '"':        goto yy831;
        case '$':        goto yy833;
        case '%':        goto yy835;
        case '&':        goto yy836;
        case '(':        goto yy837;
        case ')':        goto yy839;
        case '+':        goto yy841;
        case ',':        goto yy843;
        case '-':        goto yy845;
        case '.':        goto yy847;
        case '/':        goto yy849;
        case '0':        goto yy850;
        case '1':        goto yy852;
        case '2':        goto yy853;
        case '3':        goto yy854;
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy855;
        case ':':        goto yy857;
        case ';':        goto yy859;
        case '<':        goto yy861;
        case '=':        goto yy863;
        case '>':        goto yy865;
        case '@':        goto yy867;
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'X':
        case 'Y':
        case 'Z':
        case 'q':
        case 'v':
        case 'y':
        case 'z':        goto yy868;
        case 'W':        goto yy871;
        case '[':        goto yy872;
        case ']':        goto yy874;
        case '_':        goto yy876;
        case 'a':        goto yy879;
        case 'b':        goto yy880;
        case 'c':        goto yy881;
        case 'd':        goto yy882;
        case 'e':        goto yy883;
        case 'f':        goto yy884;
        case 'g':        goto yy885;
        case 'h':        goto yy886;
        case 'i':        goto yy887;
        case 'j':        goto yy888;
        case 'k':        goto yy889;
        case 'l':        goto yy890;
        case 'm':        goto yy891;
        case 'n':        goto yy892;
        case 'o':        goto yy893;
        case 'p':        goto yy894;
        case 'r':        goto yy895;
        case 's':        goto yy896;
        case 't':        goto yy897;
        case 'u':        goto yy898;
        case 'w':        goto yy899;
        case 'x':        goto yy900;
        case '{':        goto yy901;
        case '}':        goto yy903;
        default:        goto yy828;
        }
yy828:
        { syntaxError(curPos, "Syntax error"); }
yy829:
        ++curPos;
        { --curPos; return EEndOfSource; }
yy831:
        ++curPos;
        { return EQuot;   }
yy833:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy905;
        case 'c':
        case 'q':        goto yy906;
        case 'd':        goto yy907;
        case 'f':        goto yy908;
        case 'l':        goto yy909;
        case 'n':        goto yy910;
        case 's':        goto yy911;
        case 'z':        goto yy912;
        default:        goto yy834;
        }
yy834:
        curPos = marker;
        switch (yyaccept) {
        case 0:         goto yy828;
        case 1:         goto yy842;
        case 2:         goto yy846;
        case 3:         goto yy851;
        case 4:         goto yy925;
        case 5:         goto yy933;
        case 6:         goto yy1081;
        default:        goto yy870;
        }
yy835:
        yych = *++curPos;
        switch (yych) {
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy913;
        default:        goto yy834;
        }
yy836:
        yych = *++curPos;
        switch (yych) {
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy916;
        default:        goto yy834;
        }
yy837:
        ++curPos;
        { return ELParen; }
yy839:
        ++curPos;
        { return ERParen; }
yy841:
        yyaccept = 1;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '.':        goto yy919;
        case '0':        goto yy920;
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy921;
        default:        goto yy842;
        }
yy842:
        { return EPlus;   }
yy843:
        ++curPos;
        { return EComma;  }
yy845:
        yyaccept = 2;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '.':        goto yy919;
        case '0':        goto yy920;
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy921;
        default:        goto yy846;
        }
yy846:
        { return EMinus;  }
yy847:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy923;
        default:        goto yy848;
        }
yy848:
        { return EDot;    }
yy849:
        yych = *++curPos;
        switch (yych) {
        case '*':        goto yy926;
        case '/':        goto yy928;
        default:        goto yy834;
        }
yy850:
        yyaccept = 3;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '.':
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'E':
        case 'e':        goto yy932;
        case 'D':
        case 'd':        goto yy934;
        case 'F':
        case 'f':        goto yy936;
        case 'H':
        case 'h':        goto yy937;
        case 'X':
        case 'x':        goto yy938;
        default:        goto yy851;
        }
yy851:
        { brigId = ELitDecimal; return EIntLiteral; }
yy852:
        yyaccept = 3;
        yych = *(marker = ++curPos);
        switch (yych) {
        case 'd':        goto yy939;
        default:        goto yy856;
        }
yy853:
        yyaccept = 3;
        yych = *(marker = ++curPos);
        switch (yych) {
        case 'd':        goto yy940;
        default:        goto yy856;
        }
yy854:
        yyaccept = 3;
        yych = *(marker = ++curPos);
        switch (yych) {
        case 'd':        goto yy941;
        default:        goto yy856;
        }
yy855:
        yyaccept = 3;
        yych = *(marker = ++curPos);
yy856:
        switch (yych) {
        case '.':        goto yy923;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy855;
        case 'E':
        case 'e':        goto yy935;
        default:        goto yy851;
        }
yy857:
        ++curPos;
        { return EColon;  }
yy859:
        ++curPos;
        { return ESemi;   }
yy861:
        yych = *++curPos;
        switch (yych) {
        case '#':        goto yy942;
        default:        goto yy862;
        }
yy862:
        { return ELAngle; }
yy863:
        ++curPos;
        { return EEqual;  }
yy865:
        ++curPos;
        { return ERAngle; }
yy867:
        yych = *++curPos;
        switch (yych) {
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy944;
        default:        goto yy834;
        }
yy868:
        yych = *++curPos;
yy869:
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy870;
        }
yy870:
        { return EExtInstName;  }
yy871:
        yych = *++curPos;
        switch (yych) {
        case 'A':        goto yy947;
        default:        goto yy869;
        }
yy872:
        ++curPos;
        { return ELBrace; }
yy874:
        ++curPos;
        { return ERBrace; }
yy876:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy876;
        default:        goto yy878;
        }
yy878:
        { return EExtInstSuff;  }
yy879:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'e':
        case 'f':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'm':
        case 'o':
        case 'p':
        case 'q':
        case 's':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'b':        goto yy950;
        case 'c':        goto yy951;
        case 'd':        goto yy952;
        case 'g':        goto yy953;
        case 'l':        goto yy954;
        case 'n':        goto yy955;
        case 'r':        goto yy956;
        case 't':        goto yy957;
        default:        goto yy948;
        }
yy880:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy958;
        case 'g':        goto yy959;
        case 'i':        goto yy960;
        case 'o':        goto yy961;
        case 'r':        goto yy962;
        case 'y':        goto yy963;
        default:        goto yy869;
        }
yy881:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy964;
        case 'b':        goto yy965;
        case 'e':        goto yy966;
        case 'h':        goto yy967;
        case 'l':        goto yy968;
        case 'm':        goto yy969;
        case 'o':        goto yy970;
        case 'u':        goto yy971;
        case 'v':        goto yy972;
        default:        goto yy869;
        }
yy882:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy973;
        case 'i':        goto yy974;
        default:        goto yy869;
        }
yy883:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy975;
        case 'x':        goto yy976;
        default:        goto yy869;
        }
yy884:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy977;
        case '3':        goto yy978;
        case '6':        goto yy979;
        case 'b':        goto yy980;
        case 'i':        goto yy981;
        case 'l':        goto yy982;
        case 'm':        goto yy983;
        case 'r':        goto yy984;
        case 't':        goto yy985;
        case 'u':        goto yy986;
        default:        goto yy869;
        }
yy885:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy987;
        case 'l':        goto yy988;
        case 'r':        goto yy989;
        default:        goto yy869;
        }
yy886:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy990;
        case 'e':        goto yy991;
        default:        goto yy869;
        }
yy887:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy992;
        case 'n':        goto yy993;
        default:        goto yy869;
        }
yy888:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy994;
        default:        goto yy869;
        }
yy889:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy995;
        default:        goto yy869;
        }
yy890:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy996;
        case 'd':        goto yy997;
        case 'e':        goto yy998;
        case 'i':        goto yy999;
        case 'o':        goto yy1000;
        case 'u':        goto yy1001;
        default:        goto yy869;
        }
yy891:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1002;
        case 'e':        goto yy1003;
        case 'i':        goto yy1004;
        case 'o':        goto yy1005;
        case 'u':        goto yy1006;
        default:        goto yy869;
        }
yy892:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1007;
        case 'e':        goto yy1008;
        case 'f':        goto yy1009;
        case 'l':        goto yy1010;
        case 'o':        goto yy1011;
        case 'r':        goto yy1012;
        case 's':        goto yy1013;
        case 'u':        goto yy1014;
        default:        goto yy869;
        }
yy893:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1015;
        default:        goto yy869;
        }
yy894:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1016;
        case 'o':        goto yy1017;
        case 'r':        goto yy1018;
        default:        goto yy869;
        }
yy895:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'b':
        case 'c':
        case 'd':
        case 'f':
        case 'h':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 'u':
        case 'v':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'a':        goto yy1021;
        case 'e':        goto yy1022;
        case 'g':        goto yy1023;
        case 'i':        goto yy1024;
        case 'o':        goto yy1025;
        case 't':        goto yy1026;
        case 'w':        goto yy1027;
        case 'x':        goto yy1028;
        default:        goto yy1019;
        }
yy896:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy1029;
        case '3':        goto yy1030;
        case '6':        goto yy1031;
        case '8':        goto yy1032;
        case 'a':        goto yy1033;
        case 'b':        goto yy1034;
        case 'c':        goto yy1035;
        case 'e':        goto yy1036;
        case 'h':        goto yy1037;
        case 'i':        goto yy1038;
        case 'n':        goto yy1039;
        case 'p':        goto yy1040;
        case 'q':        goto yy1041;
        case 'r':        goto yy1042;
        case 't':        goto yy1043;
        case 'u':        goto yy1044;
        default:        goto yy869;
        }
yy897:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1045;
        default:        goto yy869;
        }
yy898:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy1046;
        case '3':        goto yy1047;
        case '6':        goto yy1048;
        case '8':        goto yy1049;
        case 'n':        goto yy1050;
        default:        goto yy869;
        }
yy899:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1051;
        case 'i':        goto yy1052;
        case 'o':        goto yy1053;
        default:        goto yy869;
        }
yy900:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1054;
        default:        goto yy869;
        }
yy901:
        ++curPos;
        { return ELCurl;  }
yy903:
        ++curPos;
        { return ERCurl;  }
yy905:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1055;
        default:        goto yy834;
        }
yy906:
        yych = *++curPos;
        switch (yych) {
        case '0':        goto yy1056;
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1058;
        default:        goto yy834;
        }
yy907:
        yych = *++curPos;
        switch (yych) {
        case '0':        goto yy1056;
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1058;
        case 'e':        goto yy1060;
        default:        goto yy834;
        }
yy908:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1061;
        default:        goto yy834;
        }
yy909:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1062;
        default:        goto yy834;
        }
yy910:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1063;
        default:        goto yy834;
        }
yy911:
        yych = *++curPos;
        switch (yych) {
        case '0':        goto yy1056;
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1058;
        case 'm':        goto yy1064;
        default:        goto yy834;
        }
yy912:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1065;
        default:        goto yy834;
        }
yy913:
        yych = *++curPos;
        switch (yych) {
        case '.':
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy913;
        default:        goto yy915;
        }
yy915:
        { return EIDLocal;  }
yy916:
        yych = *++curPos;
        switch (yych) {
        case '.':
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy916;
        default:        goto yy918;
        }
yy918:
        { return EIDStatic; }
yy919:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy923;
        default:        goto yy834;
        }
yy920:
        yych = *++curPos;
        switch (yych) {
        case 'X':
        case 'x':        goto yy1066;
        default:        goto yy922;
        }
yy921:
        yych = *++curPos;
yy922:
        switch (yych) {
        case '.':        goto yy923;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy921;
        case 'E':
        case 'e':        goto yy935;
        default:        goto yy834;
        }
yy923:
        yyaccept = 4;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy923;
        case 'D':
        case 'd':        goto yy1067;
        case 'E':
        case 'e':        goto yy935;
        case 'F':
        case 'f':        goto yy1069;
        case 'H':
        case 'h':        goto yy1071;
        default:        goto yy925;
        }
yy925:
        { brigId = ELitDecimal;           return EF64Literal; }
yy926:
        ++curPos;
        { return EMLCommentStart; }
yy928:
        yych = *++curPos;
        switch (yych) {
        case 0x00:
        case '\n':
        case '\r':        goto yy930;
        default:        goto yy928;
        }
yy930:
        { return ESLComment; }
yy931:
        yyaccept = 5;
        yych = *(marker = ++curPos);
yy932:
        switch (yych) {
        case '.':        goto yy923;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':        goto yy931;
        case '8':
        case '9':        goto yy921;
        case 'E':
        case 'e':        goto yy935;
        default:        goto yy933;
        }
yy933:
        { brigId = ELitOctal;   return EIntLiteral; }
yy934:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1073;
        default:        goto yy834;
        }
yy935:
        yych = *++curPos;
        switch (yych) {
        case '+':
        case '-':        goto yy1074;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1075;
        default:        goto yy834;
        }
yy936:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1077;
        default:        goto yy834;
        }
yy937:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1078;
        default:        goto yy834;
        }
yy938:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1079;
        default:        goto yy834;
        }
yy939:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        case 'a':        goto yy1084;
        case 'b':        goto yy1085;
        default:        goto yy1082;
        }
yy940:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'b':
        case 'c':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        case 'a':        goto yy1088;
        case 'd':        goto yy1089;
        default:        goto yy1086;
        }
yy941:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy1090;
        }
yy942:
        ++curPos;
        { scanEmbeddedText(t); return EEmbeddedText; }
yy944:
        yych = *++curPos;
        switch (yych) {
        case '.':
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy944;
        default:        goto yy946;
        }
yy946:
        { return ELabel;    }
yy947:
        yych = *++curPos;
        switch (yych) {
        case 'V':        goto yy1092;
        default:        goto yy869;
        }
yy948:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_A; return EImageOrder;
	default: return EEmpty; } }
yy950:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1093;
        case 's':        goto yy1094;
        default:        goto yy869;
        }
yy951:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1095;
        default:        goto yy869;
        }
yy952:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1096;
        default:        goto yy869;
        }
yy953:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1097;
        default:        goto yy869;
        }
yy954:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1098;
        case 'l':        goto yy1099;
        default:        goto yy869;
        }
yy955:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1100;
        default:        goto yy869;
        }
yy956:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1101;
        case 'r':        goto yy1102;
        default:        goto yy869;
        }
yy957:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1103;
        default:        goto yy869;
        }
yy958:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1104;
        default:        goto yy869;
        }
yy959:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1105;
        default:        goto yy869;
        }
yy960:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1106;
        default:        goto yy869;
        }
yy961:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1107;
        default:        goto yy869;
        }
yy962:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1108;
        }
yy963:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1110;
        default:        goto yy869;
        }
yy964:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1111;
        case 'r':        goto yy1112;
        case 's':        goto yy1113;
        default:        goto yy869;
        }
yy965:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1114;
        default:        goto yy869;
        }
yy966:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1115;
        default:        goto yy869;
        }
yy967:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1116;
        default:        goto yy869;
        }
yy968:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1117;
        case 'e':        goto yy1118;
        case 'o':        goto yy1119;
        default:        goto yy869;
        }
yy969:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1120;
        case 'p':        goto yy1121;
        default:        goto yy869;
        }
yy970:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1122;
        case 'n':        goto yy1123;
        case 'o':        goto yy1124;
        case 'p':        goto yy1125;
        default:        goto yy869;
        }
yy971:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1126;
        case 'r':        goto yy1127;
        default:        goto yy869;
        }
yy972:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1128;
        default:        goto yy869;
        }
yy973:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1129;
        case 'c':        goto yy1130;
        case 'p':        goto yy1131;
        default:        goto yy869;
        }
yy974:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1132;
        case 'v':        goto yy1133;
        default:        goto yy869;
        }
yy975:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1134;
        default:        goto yy869;
        }
yy976:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1135;
        case 't':        goto yy1136;
        default:        goto yy869;
        }
yy977:
        yych = *++curPos;
        switch (yych) {
        case '6':        goto yy1137;
        default:        goto yy869;
        }
yy978:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1138;
        default:        goto yy869;
        }
yy979:
        yych = *++curPos;
        switch (yych) {
        case '4':        goto yy1139;
        default:        goto yy869;
        }
yy980:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1140;
        default:        goto yy869;
        }
yy981:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1141;
        case 'r':        goto yy1142;
        default:        goto yy869;
        }
yy982:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1143;
        case 'o':        goto yy1144;
        default:        goto yy869;
        }
yy983:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1145;
        default:        goto yy869;
        }
yy984:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1146;
        default:        goto yy869;
        }
yy985:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1147;
        default:        goto yy869;
        }
yy986:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1148;
        default:        goto yy869;
        }
yy987:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1149;
        case 't':        goto yy1150;
        default:        goto yy869;
        }
yy988:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1151;
        default:        goto yy869;
        }
yy989:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1152;
        case 'o':        goto yy1153;
        default:        goto yy869;
        }
yy990:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1154;
        default:        goto yy869;
        }
yy991:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1155;
        default:        goto yy869;
        }
yy992:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1156;
        default:        goto yy869;
        }
yy993:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1157;
        case 'i':        goto yy1158;
        case 't':        goto yy1159;
        default:        goto yy869;
        }
yy994:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1160;
        default:        goto yy869;
        }
yy995:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1161;
        default:        goto yy869;
        }
yy996:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1162;
        case 's':        goto yy1163;
        default:        goto yy869;
        }
yy997:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'a':        goto yy1166;
        case 'f':        goto yy1167;
        case 'q':        goto yy1168;
        default:        goto yy1164;
        }
yy998:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1169;
        case 'r':        goto yy1170;
        default:        goto yy869;
        }
yy999:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1171;
        default:        goto yy869;
        }
yy1000:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1172;
        default:        goto yy869;
        }
yy1001:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1173;
        default:        goto yy869;
        }
yy1002:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1174;
        case 'x':        goto yy1175;
        default:        goto yy869;
        }
yy1003:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1176;
        default:        goto yy869;
        }
yy1004:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1177;
        case 'r':        goto yy1178;
        default:        goto yy869;
        }
yy1005:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1179;
        case 'v':        goto yy1180;
        default:        goto yy869;
        }
yy1006:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1181;
        default:        goto yy869;
        }
yy1007:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1182;
        default:        goto yy869;
        }
yy1008:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1183;
        case 'g':        goto yy1184;
        case 'x':        goto yy1185;
        default:        goto yy869;
        }
yy1009:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1186;
        default:        goto yy869;
        }
yy1010:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1187;
        default:        goto yy869;
        }
yy1011:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1188;
        case 'r':        goto yy1189;
        case 't':        goto yy1190;
        default:        goto yy869;
        }
yy1012:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1191;
        case 's':        goto yy1192;
        default:        goto yy869;
        }
yy1013:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1193;
        case 'q':        goto yy1194;
        default:        goto yy869;
        }
yy1014:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1195;
        default:        goto yy869;
        }
yy1015:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1196;
        }
yy1016:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1198;
        default:        goto yy869;
        }
yy1017:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1199;
        default:        goto yy869;
        }
yy1018:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1200;
        case 'i':        goto yy1201;
        case 'o':        goto yy1202;
        default:        goto yy869;
        }
yy1019:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_R; return EImageOrder;
	default: return EEmpty; } }
yy1021:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1203;
        }
yy1022:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1205;
        case 'l':        goto yy1206;
        case 'm':        goto yy1207;
        case 'p':        goto yy1208;
        case 'q':        goto yy1209;
        case 't':        goto yy1210;
        default:        goto yy869;
        }
yy1023:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'b':        goto yy1213;
        case 'x':        goto yy1214;
        default:        goto yy1211;
        }
yy1024:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1215;
        default:        goto yy869;
        }
yy1025:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1216;
        default:        goto yy869;
        }
yy1026:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1217;
        default:        goto yy869;
        }
yy1027:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1218;
        default:        goto yy869;
        }
yy1028:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1219;
        }
yy1029:
        yych = *++curPos;
        switch (yych) {
        case '6':        goto yy1221;
        default:        goto yy869;
        }
yy1030:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1222;
        default:        goto yy869;
        }
yy1031:
        yych = *++curPos;
        switch (yych) {
        case '4':        goto yy1223;
        default:        goto yy869;
        }
yy1032:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1226;
        default:        goto yy1224;
        }
yy1033:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1227;
        case 'm':        goto yy1228;
        default:        goto yy869;
        }
yy1034:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1229;
        case 'r':        goto yy1230;
        default:        goto yy869;
        }
yy1035:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1231;
        default:        goto yy869;
        }
yy1036:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1232;
        case 'g':        goto yy1233;
        case 't':        goto yy1234;
        default:        goto yy869;
        }
yy1037:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1235;
        case 'r':        goto yy1236;
        case 'u':        goto yy1237;
        default:        goto yy869;
        }
yy1038:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1238;
        default:        goto yy869;
        }
yy1039:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1239;
        default:        goto yy869;
        }
yy1040:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1240;
        default:        goto yy869;
        }
yy1041:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1241;
        default:        goto yy869;
        }
yy1042:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1242;
        default:        goto yy869;
        }
yy1043:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'p':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'o':        goto yy1245;
        case 'q':        goto yy1246;
        default:        goto yy1243;
        }
yy1044:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1247;
        default:        goto yy869;
        }
yy1045:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1248;
        default:        goto yy869;
        }
yy1046:
        yych = *++curPos;
        switch (yych) {
        case '6':        goto yy1249;
        default:        goto yy869;
        }
yy1047:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1250;
        default:        goto yy869;
        }
yy1048:
        yych = *++curPos;
        switch (yych) {
        case '4':        goto yy1251;
        default:        goto yy869;
        }
yy1049:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1254;
        default:        goto yy1252;
        }
yy1050:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1255;
        case 'n':        goto yy1256;
        case 'o':        goto yy1257;
        case 'p':        goto yy1258;
        case 's':        goto yy1259;
        default:        goto yy869;
        }
yy1051:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1260;
        case 'v':        goto yy1261;
        default:        goto yy869;
        }
yy1052:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1262;
        default:        goto yy869;
        }
yy1053:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1263;
        case 'r':        goto yy1264;
        default:        goto yy869;
        }
yy1054:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1265;
        default:        goto yy869;
        }
yy1055:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1266;
        default:        goto yy834;
        }
yy1056:
        ++curPos;
yy1057:
        { return ERegister; }
yy1058:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1058;
        default:        goto yy1057;
        }
yy1060:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1267;
        default:        goto yy834;
        }
yy1061:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1268;
        default:        goto yy834;
        }
yy1062:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1269;
        default:        goto yy834;
        }
yy1063:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1270;
        default:        goto yy834;
        }
yy1064:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1271;
        default:        goto yy834;
        }
yy1065:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1272;
        default:        goto yy834;
        }
yy1066:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1273;
        default:        goto yy834;
        }
yy1067:
        ++curPos;
        { brigId = ELitDecimalWithSuffix; return EF64Literal; }
yy1069:
        ++curPos;
        { brigId = ELitDecimalWithSuffix; return EF32Literal; }
yy1071:
        ++curPos;
        { brigId = ELitDecimalWithSuffix; return EF16Literal; }
yy1073:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1275;
        default:        goto yy834;
        }
yy1074:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1075;
        default:        goto yy834;
        }
yy1075:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1075;
        case 'D':
        case 'd':        goto yy1067;
        case 'F':
        case 'f':        goto yy1069;
        case 'H':
        case 'h':        goto yy1071;
        default:        goto yy925;
        }
yy1077:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1276;
        default:        goto yy834;
        }
yy1078:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1277;
        default:        goto yy834;
        }
yy1079:
        yyaccept = 6;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '.':        goto yy1278;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1079;
        case 'P':
        case 'p':        goto yy1280;
        default:        goto yy1081;
        }
yy1081:
        { brigId = ELitHex;     return EIntLiteral; }
yy1082:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_GEOMETRY_1D; return EImageGeometry; }
yy1084:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy1281;
        }
yy1085:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy1283;
        }
yy1086:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_GEOMETRY_2D; return EImageGeometry; }
yy1088:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        case 'd':        goto yy1287;
        default:        goto yy1285;
        }
yy1089:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1288;
        default:        goto yy834;
        }
yy1090:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_GEOMETRY_3D; return EImageGeometry; }
yy1092:
        yych = *++curPos;
        switch (yych) {
        case 'E':        goto yy1289;
        default:        goto yy869;
        }
yy1093:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1290;
        default:        goto yy869;
        }
yy1094:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1291;
        }
yy1095:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1293;
        default:        goto yy869;
        }
yy1096:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'q':        goto yy1296;
        case 'r':        goto yy1297;
        default:        goto yy1294;
        }
yy1097:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1298;
        default:        goto yy869;
        }
yy1098:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1299;
        default:        goto yy869;
        }
yy1099:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'o':        goto yy1302;
        default:        goto yy1300;
        }
yy1100:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1303;
        }
yy1101:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'b':        goto yy1307;
        default:        goto yy1305;
        }
yy1102:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1308;
        case 'i':        goto yy1309;
        default:        goto yy869;
        }
yy1103:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1310;
        default:        goto yy869;
        }
yy1104:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1311;
        default:        goto yy869;
        }
yy1105:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1312;
        default:        goto yy869;
        }
yy1106:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1313;
        case 'e':        goto yy1314;
        case 'i':        goto yy1315;
        case 'm':        goto yy1316;
        case 'r':        goto yy1317;
        case 's':        goto yy1318;
        default:        goto yy869;
        }
yy1107:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1319;
        default:        goto yy869;
        }
yy1108:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BR; return EInstruction;
	default: return EEmpty; } }
yy1110:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1320;
        default:        goto yy869;
        }
yy1111:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1321;
        default:        goto yy869;
        }
yy1112:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1322;
        default:        goto yy869;
        }
yy1113:
        yych = *++curPos;
        switch (yych) {
        case 'q':        goto yy1323;
        default:        goto yy869;
        }
yy1114:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1324;
        }
yy1115:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1326;
        default:        goto yy869;
        }
yy1116:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1327;
        default:        goto yy869;
        }
yy1117:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1328;
        case 's':        goto yy1329;
        default:        goto yy869;
        }
yy1118:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1330;
        default:        goto yy869;
        }
yy1119:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1331;
        default:        goto yy869;
        }
yy1120:
        yych = *++curPos;
        switch (yych) {
        case 'v':        goto yy1332;
        default:        goto yy869;
        }
yy1121:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1333;
        }
yy1122:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1335;
        default:        goto yy869;
        }
yy1123:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1336;
        default:        goto yy869;
        }
yy1124:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1337;
        default:        goto yy869;
        }
yy1125:
        yych = *++curPos;
        switch (yych) {
        case 'y':        goto yy1338;
        default:        goto yy869;
        }
yy1126:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1339;
        default:        goto yy869;
        }
yy1127:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1340;
        default:        goto yy869;
        }
yy1128:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1341;
        }
yy1129:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1343;
        default:        goto yy869;
        }
yy1130:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1344;
        default:        goto yy869;
        }
yy1131:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1345;
        default:        goto yy869;
        }
yy1132:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1346;
        }
yy1133:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1348;
        }
yy1134:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1350;
        default:        goto yy869;
        }
yy1135:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1351;
        default:        goto yy869;
        }
yy1136:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1352;
        default:        goto yy869;
        }
yy1137:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1355;
        default:        goto yy1353;
        }
yy1138:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1358;
        default:        goto yy1356;
        }
yy1139:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1361;
        default:        goto yy1359;
        }
yy1140:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1362;
        default:        goto yy869;
        }
yy1141:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1363;
        default:        goto yy869;
        }
yy1142:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1364;
        default:        goto yy869;
        }
yy1143:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1365;
        default:        goto yy869;
        }
yy1144:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1366;
        case 'o':        goto yy1367;
        default:        goto yy869;
        }
yy1145:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1368;
        }
yy1146:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1370;
        default:        goto yy869;
        }
yy1147:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1371;
        default:        goto yy869;
        }
yy1148:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1372;
        default:        goto yy869;
        }
yy1149:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1373;
        default:        goto yy869;
        }
yy1150:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1374;
        default:        goto yy869;
        }
yy1151:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1375;
        default:        goto yy869;
        }
yy1152:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1376;
        default:        goto yy869;
        }
yy1153:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1377;
        default:        goto yy869;
        }
yy1154:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1378;
        default:        goto yy869;
        }
yy1155:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1379;
        default:        goto yy869;
        }
yy1156:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1380;
        default:        goto yy869;
        }
yy1157:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1381;
        default:        goto yy869;
        }
yy1158:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1382;
        default:        goto yy869;
        }
yy1159:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1383;
        default:        goto yy869;
        }
yy1160:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1384;
        default:        goto yy869;
        }
yy1161:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1385;
        default:        goto yy869;
        }
yy1162:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1386;
        default:        goto yy869;
        }
yy1163:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1387;
        default:        goto yy869;
        }
yy1164:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_LD; return EInstruction;
	default: return EEmpty; } }
yy1166:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1388;
        }
yy1167:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1390;
        }
yy1168:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1392;
        default:        goto yy869;
        }
yy1169:
        yych = *++curPos;
        switch (yych) {
        case 'v':        goto yy1393;
        default:        goto yy869;
        }
yy1170:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1394;
        default:        goto yy869;
        }
yy1171:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1395;
        default:        goto yy869;
        }
yy1172:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1396;
        }
yy1173:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1398;
        default:        goto yy869;
        }
yy1174:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '2':        goto yy1401;
        default:        goto yy1399;
        }
yy1175:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'e':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'c':        goto yy1404;
        case 'd':        goto yy1405;
        case 'f':        goto yy1406;
        case 'w':        goto yy1407;
        default:        goto yy1402;
        }
yy1176:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1408;
        default:        goto yy869;
        }
yy1177:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1409;
        }
yy1178:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1411;
        default:        goto yy869;
        }
yy1179:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1412;
        default:        goto yy869;
        }
yy1180:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1413;
        }
yy1181:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '2':        goto yy1417;
        case 'h':        goto yy1418;
        default:        goto yy1415;
        }
yy1182:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1419;
        default:        goto yy869;
        }
yy1183:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1420;
        default:        goto yy869;
        }
yy1184:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1421;
        }
yy1185:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1423;
        default:        goto yy869;
        }
yy1186:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1424;
        default:        goto yy869;
        }
yy1187:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1425;
        default:        goto yy869;
        }
yy1188:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1426;
        }
yy1189:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1428;
        default:        goto yy869;
        }
yy1190:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1429;
        }
yy1191:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1431;
        default:        goto yy869;
        }
yy1192:
        yych = *++curPos;
        switch (yych) {
        case 'q':        goto yy1432;
        default:        goto yy869;
        }
yy1193:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1433;
        default:        goto yy869;
        }
yy1194:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1434;
        default:        goto yy869;
        }
yy1195:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1435;
        default:        goto yy869;
        }
yy1196:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_OR; return EInstruction;
	default: return EEmpty; } }
yy1198:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy1436;
        default:        goto yy869;
        }
yy1199:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1437;
        default:        goto yy869;
        }
yy1200:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1438;
        default:        goto yy869;
        }
yy1201:
        yych = *++curPos;
        switch (yych) {
        case 'v':        goto yy1439;
        default:        goto yy869;
        }
yy1202:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1440;
        default:        goto yy869;
        }
yy1203:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_RA; return EImageOrder;
	default: return EEmpty; } }
yy1205:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1441;
        default:        goto yy869;
        }
yy1206:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1442;
        default:        goto yy869;
        }
yy1207:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1443;
        }
yy1208:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1445;
        default:        goto yy869;
        }
yy1209:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1446;
        default:        goto yy869;
        }
yy1210:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1447;
        }
yy1211:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_RG; return EImageOrder;
	default: return EEmpty; } }
yy1213:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'a':        goto yy1451;
        case 'x':        goto yy1452;
        default:        goto yy1449;
        }
yy1214:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1453;
        }
yy1215:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1455;
        default:        goto yy869;
        }
yy1216:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1456;
        default:        goto yy869;
        }
yy1217:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1457;
        }
yy1218:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1459;
        default:        goto yy869;
        }
yy1219:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_RX; return EImageOrder;
	default: return EEmpty; } }
yy1221:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1462;
        default:        goto yy1460;
        }
yy1222:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1465;
        default:        goto yy1463;
        }
yy1223:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1468;
        default:        goto yy1466;
        }
yy1224:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S8;  return ETypedLiteral; }
yy1226:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy1469;
        case '4':        goto yy1470;
        case '8':        goto yy1471;
        default:        goto yy869;
        }
yy1227:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'h':        goto yy1474;
        default:        goto yy1472;
        }
yy1228:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1475;
        default:        goto yy869;
        }
yy1229:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1476;
        default:        goto yy869;
        }
yy1230:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1477;
        }
yy1231:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1479;
        default:        goto yy869;
        }
yy1232:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1480;
        default:        goto yy869;
        }
yy1233:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1481;
        default:        goto yy869;
        }
yy1234:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1482;
        default:        goto yy869;
        }
yy1235:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1483;
        }
yy1236:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1485;
        }
yy1237:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1487;
        default:        goto yy869;
        }
yy1238:
        yych = *++curPos;
        switch (yych) {
        case '3':        goto yy1488;
        case '6':        goto yy1489;
        case 'n':        goto yy1490;
        default:        goto yy869;
        }
yy1239:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1491;
        default:        goto yy869;
        }
yy1240:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1492;
        default:        goto yy869;
        }
yy1241:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1493;
        default:        goto yy869;
        }
yy1242:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1494;
        default:        goto yy869;
        }
yy1243:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ST; return EInstruction;
	default: return EEmpty; } }
yy1245:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1495;
        default:        goto yy869;
        }
yy1246:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1496;
        default:        goto yy869;
        }
yy1247:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1497;
        }
yy1248:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1499;
        default:        goto yy869;
        }
yy1249:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1502;
        default:        goto yy1500;
        }
yy1250:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1505;
        default:        goto yy1503;
        }
yy1251:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'x':        goto yy1508;
        default:        goto yy1506;
        }
yy1252:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U8;  return ETypedLiteral; }
yy1254:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy1509;
        case '4':        goto yy1510;
        case '8':        goto yy1511;
        default:        goto yy869;
        }
yy1255:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1512;
        default:        goto yy869;
        }
yy1256:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1513;
        default:        goto yy869;
        }
yy1257:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1514;
        default:        goto yy869;
        }
yy1258:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1515;
        default:        goto yy869;
        }
yy1259:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1516;
        default:        goto yy869;
        }
yy1260:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1517;
        default:        goto yy869;
        }
yy1261:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1518;
        default:        goto yy869;
        }
yy1262:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1519;
        default:        goto yy869;
        }
yy1263:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1520;
        default:        goto yy869;
        }
yy1264:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy1521;
        default:        goto yy869;
        }
yy1265:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1522;
        }
yy1266:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1524;
        default:        goto yy834;
        }
yy1267:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1525;
        default:        goto yy834;
        }
yy1268:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1526;
        default:        goto yy834;
        }
yy1269:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1527;
        default:        goto yy834;
        }
yy1270:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1528;
        default:        goto yy834;
        }
yy1271:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1529;
        default:        goto yy834;
        }
yy1272:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1530;
        default:        goto yy834;
        }
yy1273:
        yych = *++curPos;
        switch (yych) {
        case '.':        goto yy1278;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1273;
        case 'P':
        case 'p':        goto yy1280;
        default:        goto yy834;
        }
yy1275:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1531;
        default:        goto yy834;
        }
yy1276:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1532;
        default:        goto yy834;
        }
yy1277:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1533;
        default:        goto yy834;
        }
yy1278:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1278;
        case 'P':
        case 'p':        goto yy1280;
        default:        goto yy834;
        }
yy1280:
        yych = *++curPos;
        switch (yych) {
        case '+':
        case '-':        goto yy1534;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1535;
        default:        goto yy834;
        }
yy1281:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_GEOMETRY_1DA; return EImageGeometry; }
yy1283:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_GEOMETRY_1DB; return EImageGeometry; }
yy1285:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_GEOMETRY_2DA; return EImageGeometry; }
yy1287:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1538;
        default:        goto yy834;
        }
yy1288:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1539;
        default:        goto yy834;
        }
yy1289:
        yych = *++curPos;
        switch (yych) {
        case 'S':        goto yy1540;
        default:        goto yy869;
        }
yy1290:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1541;
        }
yy1291:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ABS; return EInstruction;
	default: return EEmpty; } }
yy1293:
        yych = *++curPos;
        switch (yych) {
        case 'v':        goto yy1543;
        default:        goto yy869;
        }
yy1294:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ADD; return EInstruction;
	default: return EEmpty; } }
yy1296:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1544;
        default:        goto yy869;
        }
yy1297:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1545;
        default:        goto yy869;
        }
yy1298:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1546;
        default:        goto yy869;
        }
yy1299:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1547;
        default:        goto yy869;
        }
yy1300:
        ++curPos;
        curPos -= 1;
        { return EKWWidthAll;  }
yy1302:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1548;
        default:        goto yy869;
        }
yy1303:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_AND; return EInstruction;
	default: return EEmpty; } }
yy1305:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_SEGMENT_ARG;       return ESegment; }
yy1307:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1549;
        }
yy1308:
        yych = *++curPos;
        switch (yych) {
        case 'y':        goto yy1551;
        default:        goto yy869;
        }
yy1309:
        yych = *++curPos;
        switch (yych) {
        case 'v':        goto yy1552;
        default:        goto yy869;
        }
yy1310:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1553;
        default:        goto yy869;
        }
yy1311:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1554;
        default:        goto yy869;
        }
yy1312:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1555;
        }
yy1313:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1557;
        default:        goto yy869;
        }
yy1314:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy1558;
        default:        goto yy869;
        }
yy1315:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1559;
        default:        goto yy869;
        }
yy1316:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1560;
        default:        goto yy869;
        }
yy1317:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1561;
        default:        goto yy869;
        }
yy1318:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1562;
        default:        goto yy869;
        }
yy1319:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1563;
        default:        goto yy869;
        }
yy1320:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1564;
        default:        goto yy869;
        }
yy1321:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1565;
        }
yy1322:
        yych = *++curPos;
        switch (yych) {
        case 'y':        goto yy1567;
        default:        goto yy869;
        }
yy1323:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1568;
        default:        goto yy869;
        }
yy1324:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CBR; return EInstruction;
	default: return EEmpty; } }
yy1326:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1569;
        }
yy1327:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1571;
        default:        goto yy869;
        }
yy1328:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1572;
        default:        goto yy869;
        }
yy1329:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1573;
        default:        goto yy869;
        }
yy1330:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1574;
        default:        goto yy869;
        }
yy1331:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy1575;
        default:        goto yy869;
        }
yy1332:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1576;
        }
yy1333:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CMP; return EInstruction;
	default: return EEmpty; } }
yy1335:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1578;
        default:        goto yy869;
        }
yy1336:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1579;
        default:        goto yy869;
        }
yy1337:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1580;
        default:        goto yy869;
        }
yy1338:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1581;
        default:        goto yy869;
        }
yy1339:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1582;
        }
yy1340:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1584;
        default:        goto yy869;
        }
yy1341:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CVT; return EInstruction;
	default: return EEmpty; } }
yy1343:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1585;
        default:        goto yy869;
        }
yy1344:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1586;
        }
yy1345:
        yych = *++curPos;
        switch (yych) {
        case 'h':        goto yy1588;
        default:        goto yy869;
        }
yy1346:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_DIM; return EInstruction;
	default: return EEmpty; } }
yy1348:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_DIV; return EInstruction;
	default: return EEmpty; } }
yy1350:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1589;
        default:        goto yy869;
        }
yy1351:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1590;
        default:        goto yy869;
        }
yy1352:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1591;
        default:        goto yy869;
        }
yy1353:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_F16; return ETypedLiteral; }
yy1355:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1592;
        case '4':        goto yy1593;
        case '8':        goto yy1594;
        default:        goto yy869;
        }
yy1356:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_F32; return ETypedLiteral; }
yy1358:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1595;
        case '4':        goto yy1596;
        default:        goto yy869;
        }
yy1359:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_F64; return ETypedLiteral; }
yy1361:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1597;
        default:        goto yy869;
        }
yy1362:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1598;
        default:        goto yy869;
        }
yy1363:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1599;
        default:        goto yy869;
        }
yy1364:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1600;
        default:        goto yy869;
        }
yy1365:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1601;
        }
yy1366:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1603;
        default:        goto yy869;
        }
yy1367:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1604;
        default:        goto yy869;
        }
yy1368:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_FMA; return EInstruction;
	default: return EEmpty; } }
yy1370:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1605;
        default:        goto yy869;
        }
yy1371:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1606;
        }
yy1372:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1608;
        default:        goto yy869;
        }
yy1373:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1609;
        default:        goto yy869;
        }
yy1374:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1610;
        default:        goto yy869;
        }
yy1375:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1611;
        default:        goto yy869;
        }
yy1376:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1612;
        case 's':        goto yy1613;
        default:        goto yy869;
        }
yy1377:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1614;
        default:        goto yy869;
        }
yy1378:
        yyaccept = 7;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '_':        goto yy1615;
        default:        goto yy869;
        }
yy1379:
        yych = *++curPos;
        switch (yych) {
        case 'h':        goto yy1616;
        default:        goto yy869;
        }
yy1380:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1617;
        default:        goto yy869;
        }
yy1381:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1618;
        default:        goto yy869;
        }
yy1382:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1619;
        default:        goto yy869;
        }
yy1383:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1620;
        default:        goto yy869;
        }
yy1384:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1621;
        default:        goto yy869;
        }
yy1385:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1622;
        case 'e':        goto yy1623;
        default:        goto yy869;
        }
yy1386:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1624;
        default:        goto yy869;
        }
yy1387:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1625;
        default:        goto yy869;
        }
yy1388:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_LDA; return EInstruction;
	default: return EEmpty; } }
yy1390:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_LDF; return EInstruction;
	default: return EEmpty; } }
yy1392:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1626;
        default:        goto yy869;
        }
yy1393:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1627;
        default:        goto yy869;
        }
yy1394:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1628;
        }
yy1395:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1630;
        default:        goto yy869;
        }
yy1396:
        ++curPos;
        curPos -= 1;
        { return EKWLoc; }
yy1398:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1631;
        default:        goto yy869;
        }
yy1399:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MAD; return EInstruction;
	default: return EEmpty; } }
yy1401:
        yych = *++curPos;
        switch (yych) {
        case '4':        goto yy1632;
        default:        goto yy869;
        }
yy1402:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MAX; return EInstruction;
	default: return EEmpty; } }
yy1404:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1633;
        default:        goto yy869;
        }
yy1405:
        yych = *++curPos;
        switch (yych) {
        case 'y':        goto yy1634;
        default:        goto yy869;
        }
yy1406:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1635;
        default:        goto yy869;
        }
yy1407:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1636;
        default:        goto yy869;
        }
yy1408:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1637;
        default:        goto yy869;
        }
yy1409:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MIN; return EInstruction;
	default: return EEmpty; } }
yy1411:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1638;
        default:        goto yy869;
        }
yy1412:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1639;
        default:        goto yy869;
        }
yy1413:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MOV; return EInstruction;
	default: return EEmpty; } }
yy1415:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MUL; return EInstruction;
	default: return EEmpty; } }
yy1417:
        yych = *++curPos;
        switch (yych) {
        case '4':        goto yy1640;
        default:        goto yy869;
        }
yy1418:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1641;
        default:        goto yy869;
        }
yy1419:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1642;
        }
yy1420:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1644;
        default:        goto yy869;
        }
yy1421:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NEG; return EInstruction;
	default: return EEmpty; } }
yy1423:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1645;
        default:        goto yy869;
        }
yy1424:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1646;
        }
yy1425:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1648;
        default:        goto yy869;
        }
yy1426:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NOP; return EInstruction;
	default: return EEmpty; } }
yy1428:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1649;
        default:        goto yy869;
        }
yy1429:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NOT; return EInstruction;
	default: return EEmpty; } }
yy1431:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1650;
        }
yy1432:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1652;
        default:        goto yy869;
        }
yy1433:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1653;
        }
yy1434:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1655;
        default:        goto yy869;
        }
yy1435:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1656;
        default:        goto yy869;
        }
yy1436:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'd':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'c':        goto yy1659;
        case 'e':        goto yy1660;
        default:        goto yy1657;
        }
yy1437:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1661;
        default:        goto yy869;
        }
yy1438:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1662;
        default:        goto yy869;
        }
yy1439:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1663;
        default:        goto yy869;
        }
yy1440:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1664;
        }
yy1441:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1666;
        default:        goto yy869;
        }
yy1442:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1667;
        default:        goto yy869;
        }
yy1443:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_REM; return EInstruction;
	default: return EEmpty; } }
yy1445:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1668;
        default:        goto yy869;
        }
yy1446:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1669;
        default:        goto yy869;
        }
yy1447:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_RET; return EInstruction;
	default: return EEmpty; } }
yy1449:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_RGB; return EImageOrder;
	default: return EEmpty; } }
yy1451:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1670;
        }
yy1452:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1672;
        }
yy1453:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_RGX; return EImageOrder;
	default: return EEmpty; } }
yy1455:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1674;
        }
yy1456:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1676;
        default:        goto yy869;
        }
yy1457:
        ++curPos;
        curPos -= 1;
        { return EKWRTI; }
yy1459:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1677;
        default:        goto yy869;
        }
yy1460:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S16; return ETypedLiteral; }
yy1462:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1678;
        case '4':        goto yy1679;
        case '8':        goto yy1680;
        default:        goto yy869;
        }
yy1463:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S32; return ETypedLiteral; }
yy1465:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1681;
        case '4':        goto yy1682;
        default:        goto yy869;
        }
yy1466:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S64; return ETypedLiteral; }
yy1468:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1683;
        default:        goto yy869;
        }
yy1469:
        yych = *++curPos;
        switch (yych) {
        case '6':        goto yy1684;
        default:        goto yy869;
        }
yy1470:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1685;
        }
yy1471:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1687;
        }
yy1472:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SAD; return EInstruction;
	default: return EEmpty; } }
yy1474:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1689;
        default:        goto yy869;
        }
yy1475:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1690;
        }
yy1476:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1692;
        default:        goto yy869;
        }
yy1477:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SBR; return EInstruction;
	default: return EEmpty; } }
yy1479:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1693;
        default:        goto yy869;
        }
yy1480:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1694;
        default:        goto yy869;
        }
yy1481:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1695;
        default:        goto yy869;
        }
yy1482:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1696;
        default:        goto yy869;
        }
yy1483:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SHL; return EInstruction;
	default: return EEmpty; } }
yy1485:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SHR; return EInstruction;
	default: return EEmpty; } }
yy1487:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1697;
        default:        goto yy869;
        }
yy1488:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1698;
        default:        goto yy869;
        }
yy1489:
        yych = *++curPos;
        switch (yych) {
        case '4':        goto yy1699;
        default:        goto yy869;
        }
yy1490:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1700;
        case 'e':        goto yy1701;
        default:        goto yy869;
        }
yy1491:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1702;
        default:        goto yy869;
        }
yy1492:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1703;
        default:        goto yy869;
        }
yy1493:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1704;
        }
yy1494:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'a':        goto yy1708;
        case 'x':        goto yy1709;
        default:        goto yy1706;
        }
yy1495:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1710;
        }
yy1496:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1712;
        default:        goto yy869;
        }
yy1497:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SUB; return EInstruction;
	default: return EEmpty; } }
yy1499:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1713;
        default:        goto yy869;
        }
yy1500:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U16; return ETypedLiteral; }
yy1502:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1714;
        case '4':        goto yy1715;
        case '8':        goto yy1716;
        default:        goto yy869;
        }
yy1503:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U32; return ETypedLiteral; }
yy1505:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1717;
        case '4':        goto yy1718;
        default:        goto yy869;
        }
yy1506:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U64; return ETypedLiteral; }
yy1508:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy1719;
        default:        goto yy869;
        }
yy1509:
        yych = *++curPos;
        switch (yych) {
        case '6':        goto yy1720;
        default:        goto yy869;
        }
yy1510:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1721;
        }
yy1511:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1723;
        }
yy1512:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1725;
        default:        goto yy869;
        }
yy1513:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1726;
        default:        goto yy869;
        }
yy1514:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1727;
        default:        goto yy869;
        }
yy1515:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1728;
        default:        goto yy869;
        }
yy1516:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1729;
        default:        goto yy869;
        }
yy1517:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1730;
        default:        goto yy869;
        }
yy1518:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1731;
        case 'i':        goto yy1732;
        default:        goto yy869;
        }
yy1519:
        yych = *++curPos;
        switch (yych) {
        case 'h':        goto yy1733;
        default:        goto yy869;
        }
yy1520:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1734;
        default:        goto yy869;
        }
yy1521:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1735;
        case 'i':        goto yy1736;
        default:        goto yy869;
        }
yy1522:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_XOR; return EInstruction;
	default: return EEmpty; } }
yy1524:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy1737;
        }
yy1525:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1739;
        default:        goto yy834;
        }
yy1526:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy1740;
        }
yy1527:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1742;
        default:        goto yy834;
        }
yy1528:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy1743;
        }
yy1529:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1745;
        default:        goto yy834;
        }
yy1530:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy1746;
        }
yy1531:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1748;
        default:        goto yy834;
        }
yy1532:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1749;
        default:        goto yy834;
        }
yy1533:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1750;
        default:        goto yy834;
        }
yy1534:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1535;
        default:        goto yy834;
        }
yy1535:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':        goto yy1535;
        case 'D':
        case 'd':        goto yy1752;
        case 'F':
        case 'f':        goto yy1753;
        case 'H':
        case 'h':        goto yy1755;
        default:        goto yy1537;
        }
yy1537:
        { brigId = ELitC99; return EF64Literal; }
yy1538:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy1757;
        default:        goto yy834;
        }
yy1539:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1758;
        default:        goto yy834;
        }
yy1540:
        yych = *++curPos;
        switch (yych) {
        case 'I':        goto yy1759;
        default:        goto yy869;
        }
yy1541:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_ABGR; return EImageOrder;
	default: return EEmpty; } }
yy1543:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1760;
        default:        goto yy869;
        }
yy1544:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1761;
        default:        goto yy869;
        }
yy1545:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1762;
        default:        goto yy869;
        }
yy1546:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1763;
        }
yy1547:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1765;
        }
yy1548:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        case 'a':        goto yy1769;
        default:        goto yy1767;
        }
yy1549:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_ARGB; return EImageOrder;
	default: return EEmpty; } }
yy1551:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1770;
        }
yy1552:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1772;
        default:        goto yy869;
        }
yy1553:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy1773;
        default:        goto yy869;
        }
yy1554:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1774;
        default:        goto yy869;
        }
yy1555:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_BGRA; return EImageOrder;
	default: return EEmpty; } }
yy1557:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1775;
        default:        goto yy869;
        }
yy1558:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1776;
        default:        goto yy869;
        }
yy1559:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1777;
        default:        goto yy869;
        }
yy1560:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1778;
        default:        goto yy869;
        }
yy1561:
        yych = *++curPos;
        switch (yych) {
        case 'v':        goto yy1779;
        default:        goto yy869;
        }
yy1562:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1780;
        default:        goto yy869;
        }
yy1563:
        yych = *++curPos;
        switch (yych) {
        case 'w':        goto yy1781;
        default:        goto yy869;
        }
yy1564:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1782;
        default:        goto yy869;
        }
yy1565:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CALL; return EInstruction;
	default: return EEmpty; } }
yy1567:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1783;
        }
yy1568:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1785;
        default:        goto yy869;
        }
yy1569:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CEIL; return EInstruction;
	default: return EEmpty; } }
yy1571:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1786;
        default:        goto yy869;
        }
yy1572:
        yyaccept = 7;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '_':        goto yy1787;
        default:        goto yy869;
        }
yy1573:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1788;
        }
yy1574:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1790;
        default:        goto yy869;
        }
yy1575:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1791;
        }
yy1576:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CMOV; return EInstruction;
	default: return EEmpty; } }
yy1578:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1793;
        default:        goto yy869;
        }
yy1579:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1794;
        }
yy1580:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1796;
        }
yy1581:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1798;
        default:        goto yy869;
        }
yy1582:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CUID; return EInstruction;
	default: return EEmpty; } }
yy1584:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1799;
        default:        goto yy869;
        }
yy1585:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1800;
        default:        goto yy869;
        }
yy1586:
        ++curPos;
        curPos -= 1;
        { brigId = 1; return EKWDecl; }
yy1588:
        yyaccept = 7;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy1803;
        default:        goto yy1801;
        }
yy1589:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1804;
        default:        goto yy869;
        }
yy1590:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1805;
        default:        goto yy869;
        }
yy1591:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1806;
        default:        goto yy869;
        }
yy1592:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1807;
        }
yy1593:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1809;
        }
yy1594:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1811;
        }
yy1595:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1813;
        }
yy1596:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1815;
        }
yy1597:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1817;
        }
yy1598:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1819;
        default:        goto yy869;
        }
yy1599:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1820;
        default:        goto yy869;
        }
yy1600:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1821;
        default:        goto yy869;
        }
yy1601:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_SEGMENT_FLAT;      return ESegment; }
yy1603:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1822;
        }
yy1604:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1824;
        }
yy1605:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1826;
        }
yy1606:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_FTOS; return EInstruction;
	default: return EEmpty; } }
yy1608:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1828;
        default:        goto yy869;
        }
yy1609:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1829;
        default:        goto yy869;
        }
yy1610:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1830;
        default:        goto yy869;
        }
yy1611:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1831;
        default:        goto yy869;
        }
yy1612:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1832;
        default:        goto yy869;
        }
yy1613:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1833;
        default:        goto yy869;
        }
yy1614:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'b':        goto yy1836;
        default:        goto yy1834;
        }
yy1615:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1837;
        default:        goto yy834;
        }
yy1616:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1838;
        default:        goto yy869;
        }
yy1617:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1839;
        }
yy1618:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1841;
        default:        goto yy869;
        }
yy1619:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1842;
        default:        goto yy869;
        }
yy1620:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1843;
        default:        goto yy869;
        }
yy1621:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1844;
        default:        goto yy869;
        }
yy1622:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1845;
        default:        goto yy869;
        }
yy1623:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1846;
        default:        goto yy869;
        }
yy1624:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1847;
        default:        goto yy869;
        }
yy1625:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1848;
        default:        goto yy869;
        }
yy1626:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1849;
        default:        goto yy869;
        }
yy1627:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1850;
        default:        goto yy869;
        }
yy1628:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_LERP; return EInstruction;
	default: return EEmpty; } }
yy1630:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1851;
        default:        goto yy869;
        }
yy1631:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1852;
        default:        goto yy869;
        }
yy1632:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'h':        goto yy1855;
        default:        goto yy1853;
        }
yy1633:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1856;
        default:        goto yy869;
        }
yy1634:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1857;
        default:        goto yy869;
        }
yy1635:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1858;
        default:        goto yy869;
        }
yy1636:
        yych = *++curPos;
        switch (yych) {
        case 'v':        goto yy1859;
        default:        goto yy869;
        }
yy1637:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1860;
        default:        goto yy869;
        }
yy1638:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1861;
        default:        goto yy869;
        }
yy1639:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1862;
        default:        goto yy869;
        }
yy1640:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'h':        goto yy1865;
        default:        goto yy1863;
        }
yy1641:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1866;
        }
yy1642:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NCOS; return EInstruction;
	default: return EEmpty; } }
yy1644:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1868;
        default:        goto yy869;
        }
yy1645:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1869;
        }
yy1646:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NFMA; return EInstruction;
	default: return EEmpty; } }
yy1648:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1871;
        }
yy1649:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1873;
        default:        goto yy869;
        }
yy1650:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NRCP; return EInstruction;
	default: return EEmpty; } }
yy1652:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1874;
        default:        goto yy869;
        }
yy1653:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NSIN; return EInstruction;
	default: return EEmpty; } }
yy1655:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1875;
        }
yy1656:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1877;
        default:        goto yy869;
        }
yy1657:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_PACK; return EInstruction;
	default: return EEmpty; } }
yy1659:
        yych = *++curPos;
        switch (yych) {
        case 'v':        goto yy1878;
        default:        goto yy869;
        }
yy1660:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1879;
        default:        goto yy869;
        }
yy1661:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1880;
        default:        goto yy869;
        }
yy1662:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1881;
        default:        goto yy869;
        }
yy1663:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1882;
        default:        goto yy869;
        }
yy1664:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_LINKAGE_PROGRAM; return ELinkage; }
yy1666:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1883;
        default:        goto yy869;
        }
yy1667:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1884;
        default:        goto yy869;
        }
yy1668:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1885;
        default:        goto yy869;
        }
yy1669:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1886;
        default:        goto yy869;
        }
yy1670:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_RGBA; return EImageOrder;
	default: return EEmpty; } }
yy1672:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_RGBX; return EImageOrder;
	default: return EEmpty; } }
yy1674:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_RINT; return EInstruction;
	default: return EEmpty; } }
yy1676:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1887;
        }
yy1677:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1889;
        }
yy1678:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1891;
        }
yy1679:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1893;
        }
yy1680:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1895;
        }
yy1681:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1897;
        }
yy1682:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1899;
        }
yy1683:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1901;
        }
yy1684:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1903;
        }
yy1685:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S8X4;  return ETypedLiteral; }
yy1687:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S8X8;  return ETypedLiteral; }
yy1689:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1905;
        }
yy1690:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_SAMP;  return EKWSampler; }
yy1692:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1907;
        }
yy1693:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1909;
        }
yy1694:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy1911;
        default:        goto yy869;
        }
yy1695:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1912;
        default:        goto yy869;
        }
yy1696:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1913;
        default:        goto yy869;
        }
yy1697:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1914;
        default:        goto yy869;
        }
yy1698:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1915;
        }
yy1699:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1917;
        }
yy1700:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1919;
        case 't':        goto yy1920;
        default:        goto yy869;
        }
yy1701:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1921;
        default:        goto yy869;
        }
yy1702:
        yyaccept = 7;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '_':        goto yy1922;
        default:        goto yy869;
        }
yy1703:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1923;
        }
yy1704:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SQRT; return EInstruction;
	default: return EEmpty; } }
yy1706:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_SRGB; return EImageOrder;
	default: return EEmpty; } }
yy1708:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1925;
        }
yy1709:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1927;
        }
yy1710:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_STOF; return EInstruction;
	default: return EEmpty; } }
yy1712:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1929;
        default:        goto yy869;
        }
yy1713:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1930;
        }
yy1714:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1932;
        }
yy1715:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1934;
        }
yy1716:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1936;
        }
yy1717:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1938;
        }
yy1718:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1940;
        }
yy1719:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1942;
        }
yy1720:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1944;
        }
yy1721:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U8X4;  return ETypedLiteral; }
yy1723:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U8X8;  return ETypedLiteral; }
yy1725:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1946;
        default:        goto yy869;
        }
yy1726:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy1947;
        default:        goto yy869;
        }
yy1727:
        yyaccept = 7;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '_':        goto yy1948;
        default:        goto yy869;
        }
yy1728:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy1949;
        default:        goto yy869;
        }
yy1729:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy1950;
        default:        goto yy869;
        }
yy1730:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1951;
        default:        goto yy869;
        }
yy1731:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy1952;
        default:        goto yy869;
        }
yy1732:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy1953;
        default:        goto yy869;
        }
yy1733:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1954;
        }
yy1734:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy1956;
        }
yy1735:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1958;
        default:        goto yy869;
        }
yy1736:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1959;
        default:        goto yy869;
        }
yy1737:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_PROFILE_BASE; return ETargetProfile; }
yy1739:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1960;
        default:        goto yy834;
        }
yy1740:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_PROFILE_FULL; return ETargetProfile; }
yy1742:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy1961;
        }
yy1743:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_ROUND_FLOAT_NEAR_EVEN; return EDefaultRound; }
yy1745:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy1963;
        }
yy1746:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_ROUND_FLOAT_ZERO;      return EDefaultRound; }
yy1748:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1965;
        default:        goto yy834;
        }
yy1749:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy1966;
        default:        goto yy834;
        }
yy1750:
        ++curPos;
        { brigId = ELitHex; return EF16Literal; }
yy1752:
        ++curPos;
        goto yy1537;
yy1753:
        ++curPos;
        { brigId = ELitC99; return EF32Literal; }
yy1755:
        ++curPos;
        { brigId = ELitC99; return EF16Literal; }
yy1757:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1967;
        default:        goto yy834;
        }
yy1758:
        yych = *++curPos;
        switch (yych) {
        case 'h':        goto yy1968;
        default:        goto yy834;
        }
yy1759:
        yych = *++curPos;
        switch (yych) {
        case 'Z':        goto yy1969;
        default:        goto yy869;
        }
yy1760:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1970;
        default:        goto yy869;
        }
yy1761:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1971;
        default:        goto yy869;
        }
yy1762:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1972;
        default:        goto yy869;
        }
yy1763:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_ALLOCATION_AGENT; return EAllocKind; }
yy1765:
        ++curPos;
        curPos -= 1;
        { return EKWAlign; }
yy1767:
        ++curPos;
        curPos -= 1;
        { return EKWAlloc; }
yy1769:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1973;
        }
yy1770:
        ++curPos;
        curPos -= 1;
        { return EKWImageArray; }
yy1772:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy1975;
        default:        goto yy869;
        }
yy1773:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'n':        goto yy1978;
        default:        goto yy1976;
        }
yy1774:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1979;
        default:        goto yy869;
        }
yy1775:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1980;
        default:        goto yy869;
        }
yy1776:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1981;
        default:        goto yy869;
        }
yy1777:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1982;
        default:        goto yy869;
        }
yy1778:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy1983;
        default:        goto yy869;
        }
yy1779:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1984;
        }
yy1780:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1986;
        default:        goto yy869;
        }
yy1781:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy1987;
        }
yy1782:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy1989;
        default:        goto yy869;
        }
yy1783:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CARRY; return EInstruction;
	default: return EEmpty; } }
yy1785:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy1990;
        default:        goto yy869;
        }
yy1786:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy1991;
        default:        goto yy869;
        }
yy1787:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1992;
        default:        goto yy834;
        }
yy1788:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CLASS; return EInstruction;
	default: return EEmpty; } }
yy1790:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1993;
        default:        goto yy869;
        }
yy1791:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CLOCK; return EInstruction;
	default: return EEmpty; } }
yy1793:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy1994;
        default:        goto yy869;
        }
yy1794:
        ++curPos;
        curPos -= 1;
        { brigId = 1; return EKWConst; }
yy1796:
        ++curPos;
        curPos -= 1;
        { return EKWSamplerCoord; }
yy1798:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy1995;
        default:        goto yy869;
        }
yy1799:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy1996;
        default:        goto yy869;
        }
yy1800:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy1997;
        default:        goto yy869;
        }
yy1801:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
                           case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_DEPTH; return EImageOrder;
                           default: return EKWImageDepth;
                           } }
yy1803:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy1998;
        default:        goto yy834;
        }
yy1804:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy1999;
        case 'd':        goto yy2000;
        default:        goto yy869;
        }
yy1805:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2001;
        }
yy1806:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2003;
        default:        goto yy869;
        }
yy1807:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_F16X2; return ETypedLiteral; }
yy1809:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_F16X4; return ETypedLiteral; }
yy1811:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_F16X8; return ETypedLiteral; }
yy1813:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_F32X2; return ETypedLiteral; }
yy1815:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_F32X4; return ETypedLiteral; }
yy1817:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_F64X2; return ETypedLiteral; }
yy1819:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2004;
        default:        goto yy869;
        }
yy1820:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2005;
        }
yy1821:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2007;
        default:        goto yy869;
        }
yy1822:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_FLOAT; return EImageFormat; }
yy1824:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_FLOOR; return EInstruction;
	default: return EEmpty; } }
yy1826:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_FRACT; return EInstruction;
	default: return EEmpty; } }
yy1828:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2008;
        default:        goto yy869;
        }
yy1829:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2009;
        default:        goto yy869;
        }
yy1830:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2010;
        default:        goto yy869;
        }
yy1831:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2011;
        }
yy1832:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2013;
        default:        goto yy869;
        }
yy1833:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2014;
        default:        goto yy869;
        }
yy1834:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_SEGMENT_GROUP;     return ESegment; }
yy1836:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2015;
        default:        goto yy869;
        }
yy1837:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy2016;
        default:        goto yy834;
        }
yy1838:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2017;
        }
yy1839:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ICALL; return EInstruction;
	default: return EEmpty; } }
yy1841:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2019;
        default:        goto yy869;
        }
yy1842:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2020;
        default:        goto yy869;
        }
yy1843:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2021;
        default:        goto yy869;
        }
yy1844:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2022;
        default:        goto yy869;
        }
yy1845:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2023;
        default:        goto yy869;
        }
yy1846:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2024;
        }
yy1847:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2026;
        }
yy1848:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2028;
        default:        goto yy869;
        }
yy1849:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2029;
        default:        goto yy869;
        }
yy1850:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy2030;
        default:        goto yy869;
        }
yy1851:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2031;
        }
yy1852:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2033;
        default:        goto yy869;
        }
yy1853:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MAD24; return EInstruction;
	default: return EEmpty; } }
yy1855:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2034;
        default:        goto yy869;
        }
yy1856:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2035;
        default:        goto yy869;
        }
yy1857:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2036;
        default:        goto yy869;
        }
yy1858:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2037;
        default:        goto yy869;
        }
yy1859:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2038;
        default:        goto yy869;
        }
yy1860:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2039;
        default:        goto yy869;
        }
yy1861:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2040;
        default:        goto yy869;
        }
yy1862:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2041;
        }
yy1863:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MUL24; return EInstruction;
	default: return EEmpty; } }
yy1865:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2043;
        default:        goto yy869;
        }
yy1866:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MULHI; return EInstruction;
	default: return EEmpty; } }
yy1868:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2044;
        default:        goto yy869;
        }
yy1869:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NEXP2; return EInstruction;
	default: return EEmpty; } }
yy1871:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NLOG2; return EInstruction;
	default: return EEmpty; } }
yy1873:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2045;
        default:        goto yy869;
        }
yy1874:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2046;
        }
yy1875:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NSQRT; return EInstruction;
	default: return EEmpty; } }
yy1877:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2048;
        default:        goto yy869;
        }
yy1878:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2049;
        default:        goto yy869;
        }
yy1879:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2050;
        case 'i':        goto yy2051;
        default:        goto yy869;
        }
yy1880:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2052;
        default:        goto yy869;
        }
yy1881:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2053;
        }
yy1882:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2055;
        default:        goto yy869;
        }
yy1883:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy2056;
        default:        goto yy869;
        }
yy1884:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2057;
        default:        goto yy869;
        }
yy1885:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2058;
        }
yy1886:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2060;
        default:        goto yy869;
        }
yy1887:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_ROIMG; return EKWImage; }
yy1889:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_RWIMG; return EKWImage; }
yy1891:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S16X2; return ETypedLiteral; }
yy1893:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S16X4; return ETypedLiteral; }
yy1895:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S16X8; return ETypedLiteral; }
yy1897:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S32X2; return ETypedLiteral; }
yy1899:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S32X4; return ETypedLiteral; }
yy1901:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S64X2; return ETypedLiteral; }
yy1903:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_S8X16; return ETypedLiteral; }
yy1905:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SADHI; return EInstruction;
	default: return EEmpty; } }
yy1907:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_SBGRA; return EImageOrder;
	default: return EEmpty; } }
yy1909:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SCALL; return EInstruction;
	default: return EEmpty; } }
yy1911:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2061;
        default:        goto yy869;
        }
yy1912:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2062;
        default:        goto yy869;
        }
yy1913:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2063;
        default:        goto yy869;
        }
yy1914:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2064;
        default:        goto yy869;
        }
yy1915:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_SIG32; return ETypedLiteral; }
yy1917:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_SIG64; return ETypedLiteral; }
yy1919:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'n':        goto yy2067;
        default:        goto yy2065;
        }
yy1920:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2068;
        default:        goto yy869;
        }
yy1921:
        yyaccept = 7;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '_':        goto yy2069;
        default:        goto yy869;
        }
yy1922:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2070;
        default:        goto yy834;
        }
yy1923:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_SEGMENT_SPILL;     return ESegment; }
yy1925:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_SRGBA; return EImageOrder;
	default: return EEmpty; } }
yy1927:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_SRGBX; return EImageOrder;
	default: return EEmpty; } }
yy1929:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2071;
        default:        goto yy869;
        }
yy1930:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_TRUNC; return EInstruction;
	default: return EEmpty; } }
yy1932:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U16X2; return ETypedLiteral; }
yy1934:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U16X4; return ETypedLiteral; }
yy1936:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U16X8; return ETypedLiteral; }
yy1938:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U32X2; return ETypedLiteral; }
yy1940:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U32X4; return ETypedLiteral; }
yy1942:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U64X2; return ETypedLiteral; }
yy1944:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_U8X16; return ETypedLiteral; }
yy1946:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2072;
        default:        goto yy869;
        }
yy1947:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2073;
        default:        goto yy869;
        }
yy1948:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2074;
        case 's':        goto yy2075;
        default:        goto yy834;
        }
yy1949:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'i':
        case 'j':
        case 'k':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'c':        goto yy2078;
        case 'h':        goto yy2079;
        case 'l':        goto yy2080;
        default:        goto yy2076;
        }
yy1950:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2081;
        default:        goto yy869;
        }
yy1951:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2082;
        default:        goto yy869;
        }
yy1952:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2083;
        default:        goto yy869;
        }
yy1953:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2084;
        }
yy1954:
        ++curPos;
        curPos -= 1;
        { return EKWImageWidth; }
yy1956:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_TYPE_WOIMG; return EKWImage; }
yy1958:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2086;
        default:        goto yy869;
        }
yy1959:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2087;
        default:        goto yy869;
        }
yy1960:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2088;
        default:        goto yy834;
        }
yy1961:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_MACHINE_LARGE; return ETargetMachine; }
yy1963:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_MACHINE_SMALL; return ETargetMachine; }
yy1965:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2089;
        default:        goto yy834;
        }
yy1966:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2090;
        default:        goto yy834;
        }
yy1967:
        yych = *++curPos;
        switch (yych) {
        case 'h':        goto yy2091;
        default:        goto yy834;
        }
yy1968:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2092;
        }
yy1969:
        yych = *++curPos;
        switch (yych) {
        case 'E':        goto yy2094;
        default:        goto yy869;
        }
yy1970:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2095;
        default:        goto yy869;
        }
yy1971:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2096;
        default:        goto yy869;
        }
yy1972:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2097;
        default:        goto yy869;
        }
yy1973:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ALLOCA; return EInstruction;
	default: return EEmpty; } }
yy1975:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy2098;
        default:        goto yy869;
        }
yy1976:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ATOMIC; return EInstruction;
	default: return EEmpty; } }
yy1978:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2099;
        default:        goto yy869;
        }
yy1979:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2100;
        }
yy1980:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2102;
        default:        goto yy869;
        }
yy1981:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2103;
        default:        goto yy869;
        }
yy1982:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2104;
        default:        goto yy869;
        }
yy1983:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2105;
        }
yy1984:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BITREV; return EInstruction;
	default: return EEmpty; } }
yy1986:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2107;
        default:        goto yy869;
        }
yy1987:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BORROW; return EInstruction;
	default: return EEmpty; } }
yy1989:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2108;
        default:        goto yy869;
        }
yy1990:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2109;
        default:        goto yy869;
        }
yy1991:
        yyaccept = 7;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '_':        goto yy2110;
        default:        goto yy869;
        }
yy1992:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2111;
        default:        goto yy834;
        }
yy1993:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2112;
        default:        goto yy869;
        }
yy1994:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2113;
        }
yy1995:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2115;
        default:        goto yy869;
        }
yy1996:
        yych = *++curPos;
        switch (yych) {
        case 'w':        goto yy2116;
        default:        goto yy869;
        }
yy1997:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2117;
        default:        goto yy869;
        }
yy1998:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2118;
        default:        goto yy834;
        }
yy1999:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2119;
        default:        goto yy869;
        }
yy2000:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2120;
        default:        goto yy869;
        }
yy2001:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_EXPAND; return EInstruction;
	default: return EEmpty; } }
yy2003:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2121;
        default:        goto yy869;
        }
yy2004:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2122;
        default:        goto yy869;
        }
yy2005:
        ++curPos;
        curPos -= 1;
        { return EKWSamplerFilter; }
yy2007:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2123;
        default:        goto yy869;
        }
yy2008:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2124;
        default:        goto yy869;
        }
yy2009:
        yych = *++curPos;
        switch (yych) {
        case 'y':        goto yy2125;
        default:        goto yy869;
        }
yy2010:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2126;
        default:        goto yy869;
        }
yy2011:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_SEGMENT_GLOBAL;    return ESegment; }
yy2013:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2127;
        default:        goto yy869;
        }
yy2014:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2128;
        default:        goto yy869;
        }
yy2015:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2129;
        default:        goto yy869;
        }
yy2016:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2130;
        default:        goto yy834;
        }
yy2017:
        ++curPos;
        curPos -= 1;
        { return EKWImageHeight; }
yy2019:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2131;
        default:        goto yy869;
        }
yy2020:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2132;
        default:        goto yy869;
        }
yy2021:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2133;
        default:        goto yy869;
        }
yy2022:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2134;
        default:        goto yy869;
        }
yy2023:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case 'b':        goto yy2137;
        default:        goto yy2135;
        }
yy2024:
        ++curPos;
        curPos -= 1;
        { return EKWKernel; }
yy2026:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_LANEID; return EInstruction;
	default: return EEmpty; } }
yy2028:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2138;
        }
yy2029:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2140;
        case 'w':        goto yy2141;
        default:        goto yy869;
        }
yy2030:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2142;
        default:        goto yy869;
        }
yy2031:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_FILTER_LINEAR;     return ESamplerFilter; }
yy2033:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2143;
        default:        goto yy869;
        }
yy2034:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2144;
        }
yy2035:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2146;
        }
yy2036:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy2148;
        default:        goto yy869;
        }
yy2037:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2149;
        case 'w':        goto yy2150;
        default:        goto yy869;
        }
yy2038:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2151;
        default:        goto yy869;
        }
yy2039:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2152;
        default:        goto yy869;
        }
yy2040:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2153;
        default:        goto yy869;
        }
yy2041:
        ++curPos;
        curPos -= 1;
        { return EKWModule; }
yy2043:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2154;
        }
yy2044:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2156;
        }
yy2045:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2158;
        default:        goto yy869;
        }
yy2046:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NRSQRT; return EInstruction;
	default: return EEmpty; } }
yy2048:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2159;
        }
yy2049:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2161;
        }
yy2050:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2163;
        default:        goto yy869;
        }
yy2051:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2164;
        default:        goto yy869;
        }
yy2052:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2165;
        default:        goto yy869;
        }
yy2053:
        ++curPos;
        curPos -= 1;
        { return EKWPragma; }
yy2055:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2166;
        }
yy2056:
        yych = *++curPos;
        switch (yych) {
        case 'y':        goto yy2168;
        default:        goto yy869;
        }
yy2057:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy2169;
        default:        goto yy869;
        }
yy2058:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_ADDRESSING_REPEAT; return ESamplerAddressingMode; }
yy2060:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2170;
        case 'n':        goto yy2171;
        default:        goto yy869;
        }
yy2061:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2172;
        }
yy2062:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2174;
        default:        goto yy869;
        }
yy2063:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2175;
        default:        goto yy869;
        }
yy2064:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2176;
        }
yy2065:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SIGNAL; return EInstruction;
	default: return EEmpty; } }
yy2067:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2178;
        default:        goto yy869;
        }
yy2068:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2179;
        default:        goto yy869;
        }
yy2069:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2180;
        default:        goto yy834;
        }
yy2070:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2181;
        default:        goto yy834;
        }
yy2071:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2182;
        case 'w':        goto yy2183;
        default:        goto yy869;
        }
yy2072:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2184;
        default:        goto yy869;
        }
yy2073:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy2185;
        default:        goto yy869;
        }
yy2074:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2186;
        default:        goto yy834;
        }
yy2075:
        yych = *++curPos;
        switch (yych) {
        case 'h':        goto yy2187;
        default:        goto yy834;
        }
yy2076:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_UNPACK; return EInstruction;
	default: return EEmpty; } }
yy2078:
        yych = *++curPos;
        switch (yych) {
        case 'v':        goto yy2188;
        default:        goto yy869;
        }
yy2079:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2189;
        default:        goto yy869;
        }
yy2080:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2190;
        default:        goto yy869;
        }
yy2081:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2191;
        default:        goto yy869;
        }
yy2082:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2192;
        default:        goto yy869;
        }
yy2083:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2193;
        default:        goto yy869;
        }
yy2084:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_WAVEID; return EInstruction;
	default: return EEmpty; } }
yy2086:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2194;
        default:        goto yy869;
        }
yy2087:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy2195;
        default:        goto yy869;
        }
yy2088:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2196;
        }
yy2089:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2198;
        default:        goto yy834;
        }
yy2090:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2199;
        default:        goto yy834;
        }
yy2091:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2200;
        }
yy2092:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_GEOMETRY_2DDEPTH; return EImageGeometry; }
yy2094:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2202;
        }
yy2095:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2204;
        default:        goto yy869;
        }
yy2096:
        yych = *++curPos;
        switch (yych) {
        case 'w':        goto yy2205;
        default:        goto yy869;
        }
yy2097:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2206;
        default:        goto yy869;
        }
yy2098:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2207;
        default:        goto yy869;
        }
yy2099:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2208;
        default:        goto yy869;
        }
yy2100:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BARRIER; return EInstruction;
	default: return EEmpty; } }
yy2102:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2209;
        }
yy2103:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2211;
        default:        goto yy869;
        }
yy2104:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2212;
        default:        goto yy869;
        }
yy2105:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BITMASK; return EInstruction;
	default: return EEmpty; } }
yy2107:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2213;
        default:        goto yy869;
        }
yy2108:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2214;
        default:        goto yy869;
        }
yy2109:
        yych = *++curPos;
        switch (yych) {
        case 'w':        goto yy2215;
        default:        goto yy869;
        }
yy2110:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2216;
        case 't':        goto yy2217;
        default:        goto yy834;
        }
yy2111:
        yych = *++curPos;
        switch (yych) {
        case '_':        goto yy2218;
        default:        goto yy834;
        }
yy2112:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2219;
        default:        goto yy869;
        }
yy2113:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_COMBINE; return EInstruction;
	default: return EEmpty; } }
yy2115:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2220;
        }
yy2116:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2222;
        default:        goto yy869;
        }
yy2117:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2223;
        default:        goto yy869;
        }
yy2118:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2224;
        default:        goto yy834;
        }
yy2119:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2225;
        default:        goto yy869;
        }
yy2120:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2226;
        default:        goto yy869;
        }
yy2121:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2227;
        default:        goto yy869;
        }
yy2122:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2228;
        }
yy2123:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2230;
        }
yy2124:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2232;
        }
yy2125:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2234;
        }
yy2126:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2236;
        default:        goto yy869;
        }
yy2127:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2237;
        default:        goto yy869;
        }
yy2128:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2238;
        }
yy2129:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2240;
        default:        goto yy869;
        }
yy2130:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2241;
        default:        goto yy834;
        }
yy2131:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2242;
        }
yy2132:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2244;
        }
yy2133:
        yych = *++curPos;
        switch (yych) {
        case 'y':        goto yy2246;
        default:        goto yy869;
        }
yy2134:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2247;
        }
yy2135:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_SEGMENT_KERNARG;   return ESegment; }
yy2137:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2249;
        default:        goto yy869;
        }
yy2138:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_LASTBIT; return EInstruction;
	default: return EEmpty; } }
yy2140:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2250;
        default:        goto yy869;
        }
yy2141:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2251;
        default:        goto yy869;
        }
yy2142:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2252;
        default:        goto yy869;
        }
yy2143:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2253;
        default:        goto yy869;
        }
yy2144:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MAD24HI; return EInstruction;
	default: return EEmpty; } }
yy2146:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MAXCUID; return EInstruction;
	default: return EEmpty; } }
yy2148:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2254;
        default:        goto yy869;
        }
yy2149:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2255;
        default:        goto yy869;
        }
yy2150:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2256;
        default:        goto yy869;
        }
yy2151:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2257;
        default:        goto yy869;
        }
yy2152:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2258;
        }
yy2153:
        yyaccept = 7;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '_':        goto yy2260;
        default:        goto yy869;
        }
yy2154:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MUL24HI; return EInstruction;
	default: return EEmpty; } }
yy2156:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_FILTER_NEAREST;    return ESamplerFilter; }
yy2158:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2261;
        default:        goto yy869;
        }
yy2159:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_NULLPTR; return EInstruction;
	default: return EEmpty; } }
yy2161:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_PACKCVT; return EInstruction;
	default: return EEmpty; } }
yy2163:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy2262;
        default:        goto yy869;
        }
yy2164:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2263;
        }
yy2165:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2265;
        }
yy2166:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_SEGMENT_PRIVATE;   return ESegment; }
yy2168:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2267;
        }
yy2169:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy2269;
        default:        goto yy869;
        }
yy2170:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2270;
        case 'g':        goto yy2271;
        case 'w':        goto yy2272;
        default:        goto yy869;
        }
yy2171:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2273;
        default:        goto yy869;
        }
yy2172:
        ++curPos;
        curPos -= 1;
        { return EKWSection; }
yy2174:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2274;
        }
yy2175:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2276;
        default:        goto yy869;
        }
yy2176:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SHUFFLE; return EInstruction;
	default: return EEmpty; } }
yy2178:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2277;
        default:        goto yy869;
        }
yy2179:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2278;
        default:        goto yy869;
        }
yy2180:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2279;
        default:        goto yy834;
        }
yy2181:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2280;
        default:        goto yy834;
        }
yy2182:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2281;
        default:        goto yy869;
        }
yy2183:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2282;
        default:        goto yy869;
        }
yy2184:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2283;
        default:        goto yy869;
        }
yy2185:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2284;
        default:        goto yy869;
        }
yy2186:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2285;
        default:        goto yy834;
        }
yy2187:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2286;
        default:        goto yy834;
        }
yy2188:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2287;
        default:        goto yy869;
        }
yy2189:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2288;
        }
yy2190:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2290;
        }
yy2191:
        yyaccept = 7;
        yych = *(marker = ++curPos);
        switch (yych) {
        case '_':        goto yy2292;
        default:        goto yy869;
        }
yy2192:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2293;
        }
yy2193:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2295;
        default:        goto yy869;
        }
yy2194:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2296;
        default:        goto yy869;
        }
yy2195:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2297;
        case 'f':        goto yy2298;
        case 'i':        goto yy2299;
        default:        goto yy869;
        }
yy2196:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_ROUND_FLOAT_DEFAULT;   return EDefaultRound; }
yy2198:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2300;
        default:        goto yy834;
        }
yy2199:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2301;
        default:        goto yy834;
        }
yy2200:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_GEOMETRY_2DADEPTH; return EImageGeometry; }
yy2202:
        ++curPos;
        curPos -= 1;
        { return EWaveSizeMacro; }
yy2204:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2303;
        default:        goto yy869;
        }
yy2205:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2304;
        default:        goto yy869;
        }
yy2206:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2305;
        default:        goto yy869;
        }
yy2207:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2306;
        default:        goto yy869;
        }
yy2208:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2307;
        default:        goto yy869;
        }
yy2209:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BITALIGN; return EInstruction;
	default: return EEmpty; } }
yy2211:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2308;
        default:        goto yy869;
        }
yy2212:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2309;
        }
yy2213:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2311;
        }
yy2214:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2313;
        }
yy2215:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2315;
        default:        goto yy869;
        }
yy2216:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2316;
        default:        goto yy834;
        }
yy2217:
        yych = *++curPos;
        switch (yych) {
        case 'y':        goto yy2317;
        default:        goto yy834;
        }
yy2218:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy2318;
        case 'e':        goto yy2319;
        default:        goto yy834;
        }
yy2219:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2320;
        default:        goto yy869;
        }
yy2220:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_COPYSIGN; return EInstruction;
	default: return EEmpty; } }
yy2222:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2321;
        default:        goto yy869;
        }
yy2223:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2322;
        }
yy2224:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2324;
        default:        goto yy834;
        }
yy2225:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2325;
        default:        goto yy869;
        }
yy2226:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2326;
        default:        goto yy869;
        }
yy2227:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2327;
        }
yy2228:
        ++curPos;
        curPos -= 1;
        { return EKWFbarrier; }
yy2230:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_FIRSTBIT; return EInstruction;
	default: return EEmpty; } }
yy2232:
        ++curPos;
        curPos -= 1;
        { return EKWFunction; }
yy2234:
        ++curPos;
        curPos -= 1;
        { return EKWImageGeometry; }
yy2236:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2329;
        default:        goto yy869;
        }
yy2237:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2330;
        default:        goto yy869;
        }
yy2238:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_GRIDSIZE; return EInstruction;
	default: return EEmpty; } }
yy2240:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2331;
        default:        goto yy869;
        }
yy2241:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2332;
        default:        goto yy834;
        }
yy2242:
        ++curPos;
        curPos -= 1;
        { brigId = 1; return EKWIndirect; }
yy2244:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_INITFBAR; return EInstruction;
	default: return EEmpty; } }
yy2246:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2333;
        }
yy2247:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_JOINFBAR; return EInstruction;
	default: return EEmpty; } }
yy2249:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2335;
        default:        goto yy869;
        }
yy2250:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2336;
        default:        goto yy869;
        }
yy2251:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2337;
        default:        goto yy869;
        }
yy2252:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2338;
        }
yy2253:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2340;
        }
yy2254:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2342;
        default:        goto yy869;
        }
yy2255:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2343;
        default:        goto yy869;
        }
yy2256:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2344;
        default:        goto yy869;
        }
yy2257:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2345;
        }
yy2258:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MEMFENCE; return EInstruction;
	default: return EEmpty; } }
yy2260:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2347;
        default:        goto yy834;
        }
yy2261:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2348;
        default:        goto yy869;
        }
yy2262:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2349;
        default:        goto yy869;
        }
yy2263:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_PACKETID; return EInstruction;
	default: return EEmpty; } }
yy2265:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_POPCOUNT; return EInstruction;
	default: return EEmpty; } }
yy2267:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_SEGMENT_READONLY;  return ESegment; }
yy2269:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2350;
        default:        goto yy869;
        }
yy2270:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2351;
        default:        goto yy869;
        }
yy2271:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2352;
        default:        goto yy869;
        }
yy2272:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2353;
        default:        goto yy869;
        }
yy2273:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2354;
        default:        goto yy869;
        }
yy2274:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SEGMENTP; return EInstruction;
	default: return EEmpty; } }
yy2276:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2355;
        default:        goto yy869;
        }
yy2277:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2356;
        default:        goto yy869;
        }
yy2278:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2357;
        }
yy2279:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2359;
        default:        goto yy834;
        }
yy2280:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy2360;
        case '8':        goto yy2361;
        default:        goto yy834;
        }
yy2281:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2362;
        default:        goto yy869;
        }
yy2282:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2363;
        default:        goto yy869;
        }
yy2283:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2364;
        }
yy2284:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2366;
        default:        goto yy869;
        }
yy2285:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy2367;
        case '2':        goto yy2368;
        case '8':        goto yy2369;
        case '_':        goto yy2370;
        default:        goto yy834;
        }
yy2286:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2371;
        default:        goto yy834;
        }
yy2287:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2372;
        }
yy2288:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_UNPACKHI; return EInstruction;
	default: return EEmpty; } }
yy2290:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_UNPACKLO; return EInstruction;
	default: return EEmpty; } }
yy2292:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2374;
        default:        goto yy834;
        }
yy2293:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_WAITFBAR; return EInstruction;
	default: return EEmpty; } }
yy2295:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2375;
        default:        goto yy869;
        }
yy2296:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2376;
        case 's':        goto yy2377;
        default:        goto yy869;
        }
yy2297:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy2378;
        default:        goto yy869;
        }
yy2298:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy2379;
        default:        goto yy869;
        }
yy2299:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2380;
        default:        goto yy869;
        }
yy2300:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2381;
        default:        goto yy834;
        }
yy2301:
        ++curPos;
        { brigId = ELitHex; return EF32Literal; }
yy2303:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2382;
        case 'i':        goto yy2383;
        case 'm':        goto yy2384;
        case 'p':        goto yy2385;
        default:        goto yy869;
        }
yy2304:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2386;
        default:        goto yy869;
        }
yy2305:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2387;
        }
yy2306:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2389;
        }
yy2307:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2391;
        default:        goto yy869;
        }
yy2308:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2392;
        }
yy2309:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BITINSERT; return EInstruction;
	default: return EEmpty; } }
yy2311:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BITSELECT; return EInstruction;
	default: return EEmpty; } }
yy2313:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BYTEALIGN; return EInstruction;
	default: return EEmpty; } }
yy2315:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2394;
        default:        goto yy869;
        }
yy2316:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2395;
        default:        goto yy834;
        }
yy2317:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2396;
        default:        goto yy834;
        }
yy2318:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2397;
        default:        goto yy834;
        }
yy2319:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2398;
        default:        goto yy834;
        }
yy2320:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2399;
        default:        goto yy869;
        }
yy2321:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy2400;
        default:        goto yy869;
        }
yy2322:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_DEBUGTRAP; return EInstruction;
	default: return EEmpty; } }
yy2324:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2401;
        default:        goto yy834;
        }
yy2325:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy2402;
        default:        goto yy869;
        }
yy2326:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2403;
        default:        goto yy869;
        }
yy2327:
        ++curPos;
        curPos -= 1;
        { return EKWExtension; }
yy2329:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2404;
        default:        goto yy869;
        }
yy2330:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2405;
        }
yy2331:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2407;
        default:        goto yy869;
        }
yy2332:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2408;
        }
yy2333:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_INTENSITY; return EImageOrder;
	default: return EEmpty; } }
yy2335:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2410;
        default:        goto yy869;
        }
yy2336:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2411;
        default:        goto yy869;
        }
yy2337:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2412;
        default:        goto yy869;
        }
yy2338:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_LEAVEFBAR; return EInstruction;
	default: return EEmpty; } }
yy2340:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_LUMINANCE; return EImageOrder;
	default: return EEmpty; } }
yy2342:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2413;
        default:        goto yy869;
        }
yy2343:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2414;
        default:        goto yy869;
        }
yy2344:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy2415;
        default:        goto yy869;
        }
yy2345:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_MAXWAVEID; return EInstruction;
	default: return EEmpty; } }
yy2347:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2416;
        default:        goto yy834;
        }
yy2348:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2417;
        }
yy2349:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy2419;
        default:        goto yy869;
        }
yy2350:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2420;
        default:        goto yy869;
        }
yy2351:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy2421;
        default:        goto yy869;
        }
yy2352:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2422;
        default:        goto yy869;
        }
yy2353:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2423;
        default:        goto yy869;
        }
yy2354:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2424;
        default:        goto yy869;
        }
yy2355:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2425;
        default:        goto yy869;
        }
yy2356:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2426;
        default:        goto yy869;
        }
yy2357:
        ++curPos;
        curPos -= 1;
        { return EKWSignature; }
yy2359:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy2427;
        case '3':        goto yy2428;
        case '8':        goto yy2429;
        default:        goto yy834;
        }
yy2360:
        yych = *++curPos;
        switch (yych) {
        case '6':        goto yy2430;
        default:        goto yy834;
        }
yy2361:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2431;
        }
yy2362:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2433;
        default:        goto yy869;
        }
yy2363:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2434;
        default:        goto yy869;
        }
yy2364:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_ADDRESSING_UNDEFINED; return ESamplerAddressingMode; }
yy2366:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2435;
        default:        goto yy869;
        }
yy2367:
        yych = *++curPos;
        switch (yych) {
        case '6':        goto yy2436;
        default:        goto yy834;
        }
yy2368:
        yych = *++curPos;
        switch (yych) {
        case '4':        goto yy2437;
        default:        goto yy834;
        }
yy2369:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2438;
        }
yy2370:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy2440;
        default:        goto yy834;
        }
yy2371:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2441;
        default:        goto yy834;
        }
yy2372:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_UNPACKCVT; return EInstruction;
	default: return EEmpty; } }
yy2374:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2442;
        default:        goto yy834;
        }
yy2375:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2443;
        default:        goto yy869;
        }
yy2376:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2444;
        default:        goto yy869;
        }
yy2377:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2445;
        default:        goto yy869;
        }
yy2378:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2446;
        default:        goto yy869;
        }
yy2379:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2447;
        default:        goto yy869;
        }
yy2380:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2448;
        }
yy2381:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2450;
        default:        goto yy834;
        }
yy2382:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2451;
        default:        goto yy869;
        }
yy2383:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2452;
        default:        goto yy869;
        }
yy2384:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2453;
        default:        goto yy869;
        }
yy2385:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2454;
        default:        goto yy869;
        }
yy2386:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2455;
        default:        goto yy869;
        }
yy2387:
        ++curPos;
        curPos -= 1;
        { return EKWSamplerAddressing; }
yy2389:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ARRIVEFBAR; return EInstruction;
	default: return EEmpty; } }
yy2391:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2456;
        }
yy2392:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_BITEXTRACT; return EInstruction;
	default: return EEmpty; } }
yy2394:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2458;
        default:        goto yy869;
        }
yy2395:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2459;
        default:        goto yy834;
        }
yy2396:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2460;
        default:        goto yy834;
        }
yy2397:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2461;
        default:        goto yy834;
        }
yy2398:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2462;
        default:        goto yy834;
        }
yy2399:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2463;
        default:        goto yy869;
        }
yy2400:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2464;
        case 'i':        goto yy2465;
        default:        goto yy869;
        }
yy2401:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2466;
        default:        goto yy834;
        }
yy2402:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2467;
        default:        goto yy869;
        }
yy2403:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2468;
        default:        goto yy869;
        }
yy2404:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2469;
        default:        goto yy869;
        }
yy2405:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_GRIDGROUPS; return EInstruction;
	default: return EEmpty; } }
yy2407:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2470;
        default:        goto yy869;
        }
yy2408:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_HALF_FLOAT; return EImageFormat; }
yy2410:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2471;
        default:        goto yy869;
        }
yy2411:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2472;
        default:        goto yy869;
        }
yy2412:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2473;
        default:        goto yy869;
        }
yy2413:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2474;
        default:        goto yy869;
        }
yy2414:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2475;
        default:        goto yy869;
        }
yy2415:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2476;
        default:        goto yy869;
        }
yy2416:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2477;
        default:        goto yy834;
        }
yy2417:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_COORD_NORMALIZED; return ESamplerCoord; }
yy2419:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2478;
        default:        goto yy869;
        }
yy2420:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2479;
        }
yy2421:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2481;
        }
yy2422:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2483;
        default:        goto yy869;
        }
yy2423:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy2484;
        default:        goto yy869;
        }
yy2424:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2485;
        default:        goto yy869;
        }
yy2425:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2486;
        default:        goto yy869;
        }
yy2426:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2487;
        }
yy2427:
        yych = *++curPos;
        switch (yych) {
        case '6':        goto yy2489;
        default:        goto yy834;
        }
yy2428:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy2490;
        default:        goto yy834;
        }
yy2429:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2491;
        }
yy2430:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2493;
        }
yy2431:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_SNORM_INT8; return EImageFormat; }
yy2433:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2495;
        default:        goto yy869;
        }
yy2434:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2496;
        default:        goto yy869;
        }
yy2435:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2497;
        default:        goto yy869;
        }
yy2436:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2498;
        }
yy2437:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2500;
        }
yy2438:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_UNORM_INT8; return EImageFormat; }
yy2440:
        yych = *++curPos;
        switch (yych) {
        case '0':        goto yy2502;
        default:        goto yy834;
        }
yy2441:
        yych = *++curPos;
        switch (yych) {
        case '_':        goto yy2503;
        default:        goto yy834;
        }
yy2442:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2504;
        default:        goto yy834;
        }
yy2443:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2505;
        }
yy2444:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2507;
        }
yy2445:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2509;
        default:        goto yy869;
        }
yy2446:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2510;
        default:        goto yy869;
        }
yy2447:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2511;
        default:        goto yy869;
        }
yy2448:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_WORKITEMID; return EInstruction;
	default: return EEmpty; } }
yy2450:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2512;
        default:        goto yy834;
        }
yy2451:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2513;
        default:        goto yy869;
        }
yy2452:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2514;
        }
yy2453:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2516;
        default:        goto yy869;
        }
yy2454:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2517;
        default:        goto yy869;
        }
yy2455:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2518;
        default:        goto yy869;
        }
yy2456:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ATOMICNORET; return EInstruction;
	default: return EEmpty; } }
yy2458:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2519;
        default:        goto yy869;
        }
yy2459:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2520;
        default:        goto yy834;
        }
yy2460:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2521;
        }
yy2461:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2523;
        default:        goto yy834;
        }
yy2462:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2524;
        default:        goto yy834;
        }
yy2463:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2525;
        default:        goto yy869;
        }
yy2464:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2526;
        default:        goto yy869;
        }
yy2465:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2527;
        default:        goto yy869;
        }
yy2466:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy2528;
        default:        goto yy834;
        }
yy2467:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2529;
        default:        goto yy869;
        }
yy2468:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2530;
        default:        goto yy869;
        }
yy2469:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2531;
        default:        goto yy869;
        }
yy2470:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2532;
        }
yy2471:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2534;
        default:        goto yy869;
        }
yy2472:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2535;
        default:        goto yy869;
        }
yy2473:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2536;
        default:        goto yy869;
        }
yy2474:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2537;
        default:        goto yy869;
        }
yy2475:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2538;
        default:        goto yy869;
        }
yy2476:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2539;
        default:        goto yy869;
        }
yy2477:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2540;
        default:        goto yy834;
        }
yy2478:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2541;
        default:        goto yy869;
        }
yy2479:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_RELEASEFBAR; return EInstruction;
	default: return EEmpty; } }
yy2481:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CONTROL_REQUIREDDIM; return EControl; }
yy2483:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2542;
        default:        goto yy869;
        }
yy2484:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2543;
        default:        goto yy869;
        }
yy2485:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2544;
        default:        goto yy869;
        }
yy2486:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2545;
        default:        goto yy869;
        }
yy2487:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SIGNALNORET; return EInstruction;
	default: return EEmpty; } }
yy2489:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2546;
        }
yy2490:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2548;
        }
yy2491:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_SIGNED_INT8; return EImageFormat; }
yy2493:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_SNORM_INT16; return EImageFormat; }
yy2495:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2550;
        default:        goto yy869;
        }
yy2496:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2551;
        default:        goto yy869;
        }
yy2497:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2552;
        }
yy2498:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_UNORM_INT16; return EImageFormat; }
yy2500:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_UNORM_INT24; return EImageFormat; }
yy2502:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy2554;
        default:        goto yy834;
        }
yy2503:
        yych = *++curPos;
        switch (yych) {
        case '5':        goto yy2555;
        default:        goto yy834;
        }
yy2504:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy2556;
        case '3':        goto yy2557;
        case '8':        goto yy2558;
        default:        goto yy834;
        }
yy2505:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_WAVEBARRIER; return EInstruction;
	default: return EEmpty; } }
yy2507:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_WORKGROUPID; return EInstruction;
	default: return EEmpty; } }
yy2509:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2559;
        default:        goto yy869;
        }
yy2510:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2560;
        default:        goto yy869;
        }
yy2511:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2561;
        case 'i':        goto yy2562;
        default:        goto yy869;
        }
yy2512:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2563;
        default:        goto yy834;
        }
yy2513:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2564;
        default:        goto yy869;
        }
yy2514:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ACTIVELANEID; return EInstruction;
	default: return EEmpty; } }
yy2516:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy2565;
        default:        goto yy869;
        }
yy2517:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy2566;
        default:        goto yy869;
        }
yy2518:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2567;
        default:        goto yy869;
        }
yy2519:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2568;
        default:        goto yy869;
        }
yy2520:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2569;
        }
yy2521:
        ++curPos;
        curPos -= 1;
        { return EKWImageChannelType; }
yy2523:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2571;
        default:        goto yy834;
        }
yy2524:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2572;
        }
yy2525:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2574;
        default:        goto yy869;
        }
yy2526:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2575;
        default:        goto yy869;
        }
yy2527:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2576;
        default:        goto yy869;
        }
yy2528:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2577;
        }
yy2529:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2579;
        default:        goto yy869;
        }
yy2530:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2580;
        default:        goto yy869;
        }
yy2531:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2581;
        default:        goto yy869;
        }
yy2532:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_GROUPBASEPTR; return EInstruction;
	default: return EEmpty; } }
yy2534:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2582;
        default:        goto yy869;
        }
yy2535:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2583;
        default:        goto yy869;
        }
yy2536:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2584;
        default:        goto yy869;
        }
yy2537:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2585;
        default:        goto yy869;
        }
yy2538:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2586;
        default:        goto yy869;
        }
yy2539:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2587;
        default:        goto yy869;
        }
yy2540:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2588;
        default:        goto yy834;
        }
yy2541:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2589;
        default:        goto yy869;
        }
yy2542:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2590;
        default:        goto yy869;
        }
yy2543:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2591;
        default:        goto yy869;
        }
yy2544:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2592;
        default:        goto yy869;
        }
yy2545:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2593;
        default:        goto yy869;
        }
yy2546:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_SIGNED_INT16; return EImageFormat; }
yy2548:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_SIGNED_INT32; return EImageFormat; }
yy2550:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2594;
        default:        goto yy869;
        }
yy2551:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2595;
        default:        goto yy869;
        }
yy2552:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_COORD_UNNORMALIZED; return ESamplerCoord; }
yy2554:
        yych = *++curPos;
        switch (yych) {
        case '0':        goto yy2596;
        default:        goto yy834;
        }
yy2555:
        yych = *++curPos;
        switch (yych) {
        case '5':        goto yy2597;
        case '6':        goto yy2598;
        default:        goto yy834;
        }
yy2556:
        yych = *++curPos;
        switch (yych) {
        case '6':        goto yy2599;
        default:        goto yy834;
        }
yy2557:
        yych = *++curPos;
        switch (yych) {
        case '2':        goto yy2600;
        default:        goto yy834;
        }
yy2558:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2601;
        }
yy2559:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2603;
        }
yy2560:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2605;
        }
yy2561:
        yych = *++curPos;
        switch (yych) {
        case 'b':        goto yy2607;
        default:        goto yy869;
        }
yy2562:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2608;
        default:        goto yy869;
        }
yy2563:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2609;
        default:        goto yy834;
        }
yy2564:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2610;
        default:        goto yy869;
        }
yy2565:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2611;
        }
yy2566:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2613;
        default:        goto yy869;
        }
yy2567:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2614;
        default:        goto yy869;
        }
yy2568:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2615;
        default:        goto yy869;
        }
yy2569:
        ++curPos;
        curPos -= 1;
        { return EKWImageChannelOrder; }
yy2571:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2616;
        default:        goto yy834;
        }
yy2572:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_ADDRESSING_CLAMP_TO_EDGE; return ESamplerAddressingMode; }
yy2574:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2617;
        default:        goto yy869;
        }
yy2575:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2618;
        default:        goto yy869;
        }
yy2576:
        yych = *++curPos;
        switch (yych) {
        case 'm':        goto yy2619;
        default:        goto yy869;
        }
yy2577:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EImageOrderContext: brigId = BRIG_CHANNEL_ORDER_DEPTH_STENCIL; return EImageOrder;
	default: return EEmpty; } }
yy2579:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2620;
        default:        goto yy869;
        }
yy2580:
        yych = *++curPos;
        switch (yych) {
        case 'c':        goto yy2621;
        default:        goto yy869;
        }
yy2581:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2622;
        default:        goto yy869;
        }
yy2582:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2623;
        }
yy2583:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2625;
        default:        goto yy869;
        }
yy2584:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2626;
        default:        goto yy869;
        }
yy2585:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2627;
        default:        goto yy869;
        }
yy2586:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2628;
        default:        goto yy869;
        }
yy2587:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2629;
        default:        goto yy869;
        }
yy2588:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2630;
        default:        goto yy834;
        }
yy2589:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2631;
        default:        goto yy869;
        }
yy2590:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2632;
        default:        goto yy869;
        }
yy2591:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2633;
        default:        goto yy869;
        }
yy2592:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2634;
        default:        goto yy869;
        }
yy2593:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2635;
        default:        goto yy869;
        }
yy2594:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2636;
        default:        goto yy869;
        }
yy2595:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2637;
        default:        goto yy869;
        }
yy2596:
        yych = *++curPos;
        switch (yych) {
        case '1':        goto yy2638;
        default:        goto yy834;
        }
yy2597:
        yych = *++curPos;
        switch (yych) {
        case '5':        goto yy2639;
        default:        goto yy834;
        }
yy2598:
        yych = *++curPos;
        switch (yych) {
        case '5':        goto yy2640;
        default:        goto yy834;
        }
yy2599:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2641;
        }
yy2600:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2643;
        }
yy2601:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_UNSIGNED_INT8; return EImageFormat; }
yy2603:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_WORKGROUPSIZE; return EInstruction;
	default: return EEmpty; } }
yy2605:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_WORKITEMABSID; return EInstruction;
	default: return EEmpty; } }
yy2607:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2645;
        default:        goto yy869;
        }
yy2608:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2646;
        }
yy2609:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2648;
        default:        goto yy834;
        }
yy2610:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2649;
        }
yy2611:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ACTIVELANEMASK; return EInstruction;
	default: return EEmpty; } }
yy2613:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2651;
        default:        goto yy869;
        }
yy2614:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2652;
        default:        goto yy869;
        }
yy2615:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2653;
        default:        goto yy869;
        }
yy2616:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2654;
        }
yy2617:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2656;
        default:        goto yy869;
        }
yy2618:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2657;
        default:        goto yy869;
        }
yy2619:
        yych = *++curPos;
        switch (yych) {
        case 'f':        goto yy2658;
        default:        goto yy869;
        }
yy2620:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2659;
        default:        goto yy869;
        }
yy2621:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2660;
        default:        goto yy869;
        }
yy2622:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2661;
        }
yy2623:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_KERNARGBASEPTR; return EInstruction;
	default: return EEmpty; } }
yy2625:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2663;
        default:        goto yy869;
        }
yy2626:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2664;
        default:        goto yy869;
        }
yy2627:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2665;
        default:        goto yy869;
        }
yy2628:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2666;
        }
yy2629:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2668;
        default:        goto yy869;
        }
yy2630:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2669;
        }
yy2631:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2671;
        default:        goto yy869;
        }
yy2632:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2672;
        default:        goto yy869;
        }
yy2633:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2673;
        default:        goto yy869;
        }
yy2634:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy2674;
        default:        goto yy869;
        }
yy2635:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2675;
        }
yy2636:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2677;
        default:        goto yy869;
        }
yy2637:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2678;
        default:        goto yy869;
        }
yy2638:
        yych = *++curPos;
        switch (yych) {
        case '0':        goto yy2679;
        default:        goto yy834;
        }
yy2639:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2680;
        }
yy2640:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2682;
        }
yy2641:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_UNSIGNED_INT16; return EImageFormat; }
yy2643:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_UNSIGNED_INT32; return EImageFormat; }
yy2645:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2684;
        default:        goto yy869;
        }
yy2646:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_WORKITEMFLATID; return EInstruction;
	default: return EEmpty; } }
yy2648:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2685;
        default:        goto yy834;
        }
yy2649:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ACTIVELANECOUNT; return EInstruction;
	default: return EEmpty; } }
yy2651:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2686;
        default:        goto yy869;
        }
yy2652:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2687;
        default:        goto yy869;
        }
yy2653:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2688;
        default:        goto yy869;
        }
yy2654:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_ADDRESSING_CLAMP_TO_BORDER; return ESamplerAddressingMode; }
yy2656:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2689;
        default:        goto yy869;
        }
yy2657:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2690;
        default:        goto yy869;
        }
yy2658:
        yych = *++curPos;
        switch (yych) {
        case 'l':        goto yy2691;
        default:        goto yy869;
        }
yy2659:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2692;
        default:        goto yy869;
        }
yy2660:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2693;
        default:        goto yy869;
        }
yy2661:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_GETDETECTEXCEPT; return EInstruction;
	default: return EEmpty; } }
yy2663:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2694;
        }
yy2664:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2696;
        default:        goto yy869;
        }
yy2665:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2697;
        default:        goto yy869;
        }
yy2666:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CONTROL_MAXFLATGRIDSIZE; return EControl; }
yy2668:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2698;
        default:        goto yy869;
        }
yy2669:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_ADDRESSING_MIRRORED_REPEAT; return ESamplerAddressingMode; }
yy2671:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2699;
        default:        goto yy869;
        }
yy2672:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2700;
        }
yy2673:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2702;
        default:        goto yy869;
        }
yy2674:
        yych = *++curPos;
        switch (yych) {
        case 'w':        goto yy2703;
        default:        goto yy869;
        }
yy2675:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_SETDETECTEXCEPT; return EInstruction;
	default: return EEmpty; } }
yy2677:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2704;
        }
yy2678:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2706;
        default:        goto yy869;
        }
yy2679:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy834;
        default:        goto yy2707;
        }
yy2680:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_UNORM_SHORT_555; return EImageFormat; }
yy2682:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_UNORM_SHORT_565; return EImageFormat; }
yy2684:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2709;
        default:        goto yy869;
        }
yy2685:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':        goto yy2710;
        default:        goto yy834;
        }
yy2686:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2712;
        }
yy2687:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2714;
        default:        goto yy869;
        }
yy2688:
        yych = *++curPos;
        switch (yych) {
        case 'x':        goto yy2715;
        default:        goto yy869;
        }
yy2689:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2716;
        }
yy2690:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2718;
        default:        goto yy869;
        }
yy2691:
        yych = *++curPos;
        switch (yych) {
        case 'a':        goto yy2719;
        default:        goto yy869;
        }
yy2692:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2720;
        default:        goto yy869;
        }
yy2693:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2721;
        default:        goto yy869;
        }
yy2694:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_LDQUEUEREADINDEX; return EInstruction;
	default: return EEmpty; } }
yy2696:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2722;
        }
yy2697:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2724;
        default:        goto yy869;
        }
yy2698:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2725;
        default:        goto yy869;
        }
yy2699:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2726;
        default:        goto yy869;
        }
yy2700:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CONTROL_REQUIREDGRIDSIZE; return EControl; }
yy2702:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2727;
        default:        goto yy869;
        }
yy2703:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2728;
        default:        goto yy869;
        }
yy2704:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_STQUEUEREADINDEX; return EInstruction;
	default: return EEmpty; } }
yy2706:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2729;
        }
yy2707:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CHANNEL_TYPE_UNORM_INT_101010; return EImageFormat; }
yy2709:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2731;
        }
yy2710:
        ++curPos;
        { brigId = ELitHex; return EF64Literal; }
yy2712:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ACTIVELANEPERMUTE; return EInstruction;
	default: return EEmpty; } }
yy2714:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2733;
        }
yy2715:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2735;
        }
yy2716:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CLEARDETECTEXCEPT; return EInstruction;
	default: return EEmpty; } }
yy2718:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2737;
        default:        goto yy869;
        }
yy2719:
        yych = *++curPos;
        switch (yych) {
        case 't':        goto yy2738;
        default:        goto yy869;
        }
yy2720:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2739;
        default:        goto yy869;
        }
yy2721:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2740;
        default:        goto yy869;
        }
yy2722:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_LDQUEUEWRITEINDEX; return EInstruction;
	default: return EEmpty; } }
yy2724:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2741;
        default:        goto yy869;
        }
yy2725:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2742;
        default:        goto yy869;
        }
yy2726:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2743;
        default:        goto yy869;
        }
yy2727:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2744;
        default:        goto yy869;
        }
yy2728:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2745;
        default:        goto yy869;
        }
yy2729:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_STQUEUEWRITEINDEX; return EInstruction;
	default: return EEmpty; } }
yy2731:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_WORKITEMFLATABSID; return EInstruction;
	default: return EEmpty; } }
yy2733:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_ADDQUEUEWRITEINDEX; return EInstruction;
	default: return EEmpty; } }
yy2735:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CASQUEUEWRITEINDEX; return EInstruction;
	default: return EEmpty; } }
yy2737:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2746;
        default:        goto yy869;
        }
yy2738:
        yych = *++curPos;
        switch (yych) {
        case 'i':        goto yy2747;
        default:        goto yy869;
        }
yy2739:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2748;
        default:        goto yy869;
        }
yy2740:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2749;
        default:        goto yy869;
        }
yy2741:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2750;
        }
yy2742:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2752;
        default:        goto yy869;
        }
yy2743:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2753;
        }
yy2744:
        yych = *++curPos;
        switch (yych) {
        case 'z':        goto yy2755;
        default:        goto yy869;
        }
yy2745:
        yych = *++curPos;
        switch (yych) {
        case 'k':        goto yy2756;
        default:        goto yy869;
        }
yy2746:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2757;
        }
yy2747:
        yych = *++curPos;
        switch (yych) {
        case 'd':        goto yy2759;
        default:        goto yy869;
        }
yy2748:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2760;
        default:        goto yy869;
        }
yy2749:
        yych = *++curPos;
        switch (yych) {
        case 'n':        goto yy2761;
        default:        goto yy869;
        }
yy2750:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CONTROL_MAXDYNAMICGROUPSIZE; return EControl; }
yy2752:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2762;
        }
yy2753:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_PACKETCOMPLETIONSIG; return EInstruction;
	default: return EEmpty; } }
yy2755:
        yych = *++curPos;
        switch (yych) {
        case 'e':        goto yy2764;
        default:        goto yy869;
        }
yy2756:
        yych = *++curPos;
        switch (yych) {
        case 'g':        goto yy2765;
        default:        goto yy869;
        }
yy2757:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CURRENTWORKGROUPSIZE; return EInstruction;
	default: return EEmpty; } }
yy2759:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        default:        goto yy2766;
        }
yy2760:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2768;
        }
yy2761:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2770;
        default:        goto yy869;
        }
yy2762:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CONTROL_MAXFLATWORKGROUPSIZE; return EControl; }
yy2764:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2771;
        }
yy2765:
        yych = *++curPos;
        switch (yych) {
        case 'r':        goto yy2773;
        default:        goto yy869;
        }
yy2766:
        ++curPos;
        curPos -= 1;
        { switch(ctx) {
	case EDefaultContext: brigId = BRIG_OPCODE_CURRENTWORKITEMFLATID; return EInstruction;
	default: return EEmpty; } }
yy2768:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CONTROL_ENABLEBREAKEXCEPTIONS; return EControl; }
yy2770:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2774;
        }
yy2771:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CONTROL_REQUIREDWORKGROUPSIZE; return EControl; }
yy2773:
        yych = *++curPos;
        switch (yych) {
        case 'o':        goto yy2776;
        default:        goto yy869;
        }
yy2774:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CONTROL_ENABLEDETECTEXCEPTIONS; return EControl; }
yy2776:
        yych = *++curPos;
        switch (yych) {
        case 'u':        goto yy2777;
        default:        goto yy869;
        }
yy2777:
        yych = *++curPos;
        switch (yych) {
        case 'p':        goto yy2778;
        default:        goto yy869;
        }
yy2778:
        yych = *++curPos;
        switch (yych) {
        case 's':        goto yy2779;
        default:        goto yy869;
        }
yy2779:
        yych = *++curPos;
        switch (yych) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':        goto yy868;
        case '_':        goto yy870;
        default:        goto yy2780;
        }
yy2780:
        ++curPos;
        curPos -= 1;
        { brigId = BRIG_CONTROL_REQUIRENOPARTIALWORKGROUPS; return EControl; }
}


}

bool Scanner::continueMLComment()
{
    assert(m_peekToken==NULL);
    const char* begin = m_curToken->m_text.end;
    Token& t = newToken();
    m_curToken = &t;
    t.m_lineStart = m_lineStart;
    t.m_lineNum = m_lineNum;
    const char* curPos = begin;


{
        char yych;
        yych = *curPos;
        switch (yych) {
        case '\n':        goto yy2786;
        case '\r':        goto yy2788;
        case '*':        goto yy2789;
        default:        goto yy2784;
        }
yy2784:
        ++curPos;
yy2785:
        { goto NLdone; }
yy2786:
        ++curPos;
        { nextLine(curPos); begin = curPos; goto NLdone; }
yy2788:
        yych = *++curPos;
        switch (yych) {
        case '\n':        goto yy2786;
        default:        goto yy2785;
        }
yy2789:
        yych = *++curPos;
        switch (yych) {
        case '/':        goto yy2790;
        default:        goto yy2785;
        }
yy2790:
        ++curPos;
        { t.m_text.end = t.m_text.begin = curPos; goto finish; }
}


NLdone:

  while(true) {
    const char* prevPos = curPos;

{
        char yych;
        yych = *curPos;
        switch (yych) {
        case 0x00:        goto yy2794;
        case '\n':        goto yy2798;
        case '\r':        goto yy2800;
        case '*':        goto yy2801;
        default:        goto yy2796;
        }
yy2794:
        ++curPos;
        { t.m_text.begin = begin; t.m_text.end = prevPos; syntaxError(prevPos, "Premature end of comment"); }
yy2796:
        ++curPos;
yy2797:
        { continue; }
yy2798:
        ++curPos;
        { t.m_text.begin = begin; t.m_text.end = prevPos; return true; }
yy2800:
        yych = *++curPos;
        switch (yych) {
        case '\n':        goto yy2798;
        default:        goto yy2797;
        }
yy2801:
        yych = *++curPos;
        switch (yych) {
        case '/':        goto yy2802;
        default:        goto yy2797;
        }
yy2802:
        ++curPos;
        { t.m_text.begin = begin; t.m_text.end = prevPos; return true; }
}

  }

finish: // Whitespace is required between lexical tokens that can include alphabetic or numeric characters
    if (isAlpha(*curPos) || *curPos == '@' || *curPos == '/') syntaxError(curPos, "missing white space");
    return false;
}

void Scanner::skipWhitespaces(Scanner::Token& t)
{
    const char *curPos = t.m_text.begin;
    while(true) {
        const char *const prevPos = curPos;
        const char *marker;

{
        char yych;
        yych = *(marker = curPos);
        switch (yych) {
        case 0x00:        goto yy2807;
        case '\t':
        case ' ':        goto yy2809;
        case '\n':        goto yy2811;
        case '\r':        goto yy2813;
        default:        goto yy2806;
        }
yy2806:
        { break; }
yy2807:
        ++curPos;
        { curPos = prevPos; break; }
yy2809:
        ++curPos;
        { continue; }
yy2811:
        ++curPos;
        { nextLine(curPos); continue; }
yy2813:
        yych = *++curPos;
        switch (yych) {
        case '\n':        goto yy2811;
        default:        goto yy2814;
        }
yy2814:
        curPos = marker;
        goto yy2806;
}

    }
    t.m_text.begin = t.m_text.end = curPos;
}

} // end namespace
